--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
require("frame/src/tools/bitExtend");
require("frame/src/tools/extern");
require("frame/src/tools/files");
require("frame/src/tools/UILabelEx3");
require("frame/src/tools/frame_event_switch");
require("frame/src/tools/frame_update_clock");

require("frame/src/game_layer_base");
require("frame/src/frame_tools");
require("frame/src/frame_config");
require("frame/src/frame_data_config");

require("frame/src/uilayer/frame_window")
require("frame/src/uilayer/frame_config_win")
require("frame/src/uilayer/frame_hint_win")
require("frame/src/uilayer/frame_user_info_win")
require("frame/src/uilayer/frame_user_head")
require("frame/src/uilayer/frame_report_win")
require("frame/src/uilayer/frame_task_win")
require("frame/src/uilayer/frame_test_win")
require("frame/src/uilayer/frame_chat_win")
require("frame/src/uilayer/frame_chat_play")
require("frame/src/uilayer/frame_bugle")
require("frame/src/uilayer/frame_broke_win")
require("frame/src/uilayer/frame_exit_win")
require("frame/src/uilayer/frame_gift_play")
require("frame/src/uilayer/frame_finish_base");

require("frame_config/frame_config")

require("src/game_layer");

frame_logic = require("frame/src/frame_logic");

frame_layer = class("frame_layer")
function frame_layer:ctor()
    self.m_char_str_list = {};
end

function frame_layer:init(layer, visibleSize)
    print("m_frame_layer init \n");
    self.m_screenGap = 0;
    if visibleSize.width/visibleSize.height > 17/9 then
        self.m_screenGap = 60;
    end
    --加载图片
    self:loadPlist();
    --初始化工具
    frame_tools:init(self, visibleSize);
    --初始化数据
    frame_logic:init();
    -- 初始化游戏界面
    self.main_layer = layer;
    self.visibleSize = visibleSize;
    --test窗口
    if Frame_Test_Win == true then
        self:start_test_win();
    end
    --创建背景层
    self.bg_layout = Layout:create();
    self.main_layer:addChild(self.bg_layout, 0);  
    --定时器
    self.update_clock = frame_update_clock:new();
    self.update_clock:init();
    self.bg_layout:addChild(self.update_clock);
    self.update_clock:add_callbcak(function() if self == nil or self.__update == nil then return;end self:__update() end)
    --初始化背景
--    self:init_bg_img();
    --创建中间层
    self.bg_game_middle_layout = Layout:create();
    self.main_layer:addChild(self.bg_game_middle_layout, 1);  
    --创建中间层
    self.game_window_middle_layout = Layout:create();
    self.main_layer:addChild(self.game_window_middle_layout, 3); 
    --礼物（鲜花鸡蛋）
    self.gift_play = frame_gift_play:new()
    self.game_window_middle_layout:addChild(self.gift_play);   
    self.gift_play:init();
    --聊天与表情动画
    self.chat_play = frame_chat_player:new()
    self.game_window_middle_layout:addChild(self.chat_play);   
    self.chat_play:init();
    --创建弹出窗口层
    self.window_layout = Layout:create()
    self.main_layer:addChild(self.window_layout, 4);   
    --最上层
    self.top_layout = Layout:create()
    self.main_layer:addChild(self.top_layout, 5);   
    --游戏层
    self.game_Layout = Layout:create();
    self.game_Layout:setSize(CCSizeMake(visibleSize.width, visibleSize.height) );
    self.main_layer:addChild(self.game_Layout, 2);    
    --创建与初始化游戏
    self.game_layer = game_layer:new();
    self.game_layer:init(self.game_Layout, visibleSize);

    --小喇叭
    self.bugle_bar = frame_bugle_bar:new();
    self.main_layer:addChild(self.bugle_bar);
    self.bugle_bar:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height - 80)); 
    self.bugle_bar:init();

    --查询救济金
    frame_tools:send_data(FRAME_MESSAGE.SUB_GAME_CHECK_EXTRA_DATA, "");

    --test
    self.test_win = frame_task_win:new();
    self.window_layout:addChild(self.test_win);
    self.test_win:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height/2))
    self.test_win:init();
--    self.test_win:show_task(113);
--    self.test_win:show_task_win();
end

function frame_layer:loadPlist()
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("frame/image/frame_config_win/frame_config_win.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("frame/image/frame_hint_win/frame_hint.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("frame/image/frame_user_info_win/frame_user_info.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("frame/image/frame_report_win/frame_report.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("frame/image/frame_task_win/frame_task.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("frame/image/frame_chat_win/frame_chat.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("frame/image/frame_exit_win/frame_exit_win.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("frame/image/frame_broke_win/frame_broke.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("frame/image/frame_chat_win/frame_emotion.plist");
    --表情
    for i=1,9 do
        CCArmatureDataManager:sharedArmatureDataManager():addArmatureFileInfo("frame/emotion/biaoqingdhxz0"..i..".ExportJson");
    end
    for i=10,31 do
        CCArmatureDataManager:sharedArmatureDataManager():addArmatureFileInfo("frame/emotion/biaoqingdhxz"..i..".ExportJson");
    end
end

function frame_layer:unLoadplist()
    CCSpriteFrameCache:sharedSpriteFrameCache():removeSpriteFramesFromFile("frame/image/frame_config_win/frame_config_win.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():removeSpriteFramesFromFile("frame/image/frame_hint_win/frame_hint.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():removeSpriteFramesFromFile("frame/image/frame_user_info_win/frame_user_info.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():removeSpriteFramesFromFile("frame/image/frame_report_win/frame_report.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():removeSpriteFramesFromFile("frame/image/frame_task_win/frame_task.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():removeSpriteFramesFromFile("frame/image/frame_chat_win/frame_chat.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():removeSpriteFramesFromFile("frame/image/frame_exit_win/frame_exit_win.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():removeSpriteFramesFromFile("frame/image/frame_broke_win/frame_broke.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():removeSpriteFramesFromFile("frame/image/frame_chat_win/frame_emotion.plist");
    --表情
    for i=1,9 do
        CCArmatureDataManager:sharedArmatureDataManager():removeArmatureFileInfo("frame/emotion/biaoqingdhxz0"..i..".ExportJson");
    end
    for i=10,31 do
        CCArmatureDataManager:sharedArmatureDataManager():removeArmatureFileInfo("frame/emotion/biaoqingdhxz"..i..".ExportJson");
    end
end

--玩家进入
function frame_layer:on_game_user_enter(userid, chairid, look)
    local user_data = frame_tools:get_user_data(chairid);
    frame_logic:set_user_data(chairid, user_data);

    self.game_layer:on_game_user_enter(userid, chairid, look);
end

--玩家离开
function frame_layer:on_game_user_left(userid, chairid, look)
    self.game_layer:on_game_user_left(userid, chairid, look);
end

function frame_layer:destroy()
    self.game_layer:destroy();
    if self.user_info_self then self.user_info_self:destroy(); end   
    if self.user_info_other then self.user_info_other:destroy(); end     
--    if self.broke_win then self.broke_win:destroy(); end

    self:unLoadplist();
    self.update_clock:destroy();

    CCTextureCache:sharedTextureCache():removeAllTextures();
end
--游戏消息接收
function frame_layer:on_game_message(id, data)
    if id > 10000 then
        local table_data = frame_tools:decode(data)
        if id == FRAME_MESSAGE.SUB_GAME_CHAT then
            self:on_frame_user_chat(table_data);
        elseif id == FRAME_MESSAGE.SUB_GAME_PRAISE_RET then
            self:on_frame_user_praise_ret(table_data);
        elseif id == FRAME_MESSAGE.SUB_GAME_CHECK_EXTRA_DATA_RET then
            self:on_frame_game_check_awawd_ret(table_data);
        elseif id == FRAME_MESSAGE.SUB_GAME_KICKOUT_NOTICE then
            self:on_frame_game_kickout_notice(table_data);
        elseif id == FRAME_MESSAGE.SUB_GAME_KICKOUT_RET then
            self:on_frame_game_kickout_ret(table_data);
        elseif id == FRAME_MESSAGE.SUB_GAME_RESULT_NOTICE then
            self:on_frame_game_result_notice(table_data);
        elseif id == FRAME_MESSAGE.SUB_GAME_GIFT_NOTICE then
            self:on_frame_game_gift_notice(table_data);
        elseif id == FRAME_MESSAGE.SUB_GAME_GIFT_RET then
            self:on_frame_game_gift_ret(table_data);
        elseif id == FRAME_MESSAGE.SUB_GAME_OBTAIN_AWARD_RET then
            self:on_frame_game_award_ret(table_data);
        elseif id == FRAME_MESSAGE.SUB_GAME_USER_COME then
            self:on_frame_game_user_come(table_data);
        end
        return;
    end
    self.game_layer:on_game_message(id, data);
end

function frame_layer:on_game_scene_message(status, look, data)
	self.game_layer:on_game_scene_message(status, look, data);
end

function frame_layer:on_game_user_chat(userid, chairid, chat)
--    self.game_layer:on_game_user_chat(userid, chairid, chat);
end

function frame_layer:on_system_message(kind, chat)
    if kind == 0 or kind == 2 then
        frame_tools:show_hinting(frame_tools:gbk_to_utf8(chat));
    end
--    self.game_layer:on_system_message(kind, chat);
end

--获取玩家状态
function frame_layer:on_game_user_status(userid, chairid, look, offline)
    local user_data = frame_tools:get_user_data(chairid);
    frame_logic:set_user_data(chairid,user_data);

    if user_data.user_status == FRAME_USER_STATUS.US_PLAY then
        frame_logic:set_game_status(FRAME_USER_STATUS.US_PLAY);
    else
        frame_logic:set_game_status(FRAME_USER_STATUS.US_FREE);
    end

    self.game_layer:on_game_user_status(userid, chairid, look, offline);
end

function frame_layer:on_game_user_data(userid, chairid, look)
    local user_data = frame_tools:get_user_data(chairid);
    frame_logic:set_user_data(chairid,user_data);

    frame_tools:call_event("update_user_data", user_data);
    frame_tools:close_broke_win_with_gold_up();
	self.game_layer:on_game_user_data(userid, chairid, look);
end

function frame_layer:on_game_user_score(userid, chairid, look)
    local user_data = frame_tools:get_user_data(chairid);
    frame_logic:set_user_data(chairid,user_data);

    frame_tools:call_event("update_user_data", user_data);
    frame_tools:close_broke_win_with_gold_up();
    self.game_layer:on_game_user_score(userid, chairid, look);
end
function frame_layer:on_game_friend_data()
    self.game_layer:on_game_friend_data();
end

function frame_layer:on_click_back()
    self.game_layer:on_click_back();
end

function frame_layer:on_click_menu()
	self.game_layer:on_click_menu();
end

function frame_layer:on_push_data(param_id, param_data)
    self.game_layer:on_push_data(param_id, param_data);
end

function frame_layer:on_tip_data(param_id, bool_show)
    self.game_layer:on_tip_data(param_id, bool_show);
end

-----------------------------------------------------------------------------------------------------------------------
--消息
function frame_layer:on_frame_user_chat(table_data)
    if table_data == nil then return; end
   
    local chair_id = frame_logic:get_chair_id_with_userid(table_data.userid);
    if chair_id == nil then return; end

    self.game_layer:on_game_user_chat(table_data.userid, chair_id, table_data.id);
end
--
function frame_layer:on_frame_user_praise_ret(table_data)
    if table_data == nil then return; end

    local flag = table_data.flag;

    if flag == 1 then
        frame_tools:show_hinting("您今日已给该用户点过赞了");
    elseif flag == 0 then
        frame_tools:show_hinting("点赞成功");
    end
end
--
function frame_layer:on_frame_game_check_awawd_ret(table_data)
    if table_data == nil then return; end

    frame_logic:set_alms_data(table_data.award);
    frame_logic:set_original_data(table_data.original);

    local head_frame = table_data.headframe or {};
    local head_frame_id = head_frame.id or 0;
    frame_logic:set_user_head_frame_id(frame_logic:get_self_user_id(), head_frame_id);
end
--
function frame_layer:on_frame_game_kickout_notice(table_data)
    if table_data == nil then return; end

    if table_data.touserid == frame_logic:get_self_user_id() then
        frame_tools:close_game()
        frame_tools:show_sysmessage_box("您已被踢人卡踢出房间", "提示", 0)
    end

end
--
function frame_layer:on_frame_game_kickout_ret(table_data)
    if table_data == nil then return; end

    print("table_data:",table_data.flag," ",table_data.msg);
    if table_data.flag == 0 then 
        local data = frame_logic:get_user_data_with_userid(table_data.touserid);
        if data == nil then
            frame_tools:show_hinting("踢人卡使用成功")  
        else
            frame_tools:show_hinting("玩家【"..data.nickname.."】已被踢离房间")  
        end
    elseif table_data.flag == 1 then
        frame_tools:show_hinting("正在游戏中，无法踢TA离开")  
    elseif table_data.flag == 2 then
        frame_tools:show_hinting("您无法将高等级或同等级的贵族玩家踢出房间")  
    elseif table_data.flag == 3 then
        frame_tools:show_hinting("踢人卡道具不足")  
    elseif table_data.flag == 4 then
        frame_tools:show_hinting("玩家不存在")  
    elseif table_data.flag == 5 then
        frame_tools:show_hinting("对方版本过低")  
    else    
        frame_tools:show_hinting("未知错误");
    end
    
end
--
function frame_layer:on_frame_game_result_notice(table_data)
    if table_data == nil then return; end

    frame_logic:set_user_win_lose(table_data);
end

--
function frame_layer:on_frame_game_gift_notice(table_data)
    if table_data == nil then return; end

    local userid_from = table_data.from or -1;
    local userid_to = table_data.to or -1;

    local chair_from = frame_logic:get_chair_id_with_userid(userid_from) or -1;
    local chair_to = frame_logic:get_chair_id_with_userid(userid_to) or -1;

    local gift_id = table_data.gift_id or 0;
    local gift_count = table_data.count or 1;

    if chair_from == -1 or chair_to == -1 or gift_id < FRAME_USER_PROP_ID.egg then return; end

--    local view_from = frame_tools:switch_to_chair_id(chair_from) + 1;
--    local view_to = frame_tools:switch_to_chair_id(chair_to) + 1;

--    self.gift_play:play_gift_times(view_from, view_to, gift_id - FRAME_USER_PROP_ID.egg, gift_count);
    
    self.game_layer:on_game_send_gift(chair_from, chair_to, gift_id - FRAME_USER_PROP_ID.egg, gift_count);

    ----------------------------------------------------------------------
    local gift_data = frame_logic:get_gift_info();
    if gift_data == nil then return;end
    
    local gift_price = gift_data[gift_id - FRAME_USER_PROP_ID.egg + 1];
    if gift_price == nil then return;end 

    local call_data = {}
    call_data.userid = table_data.from;
    call_data.touserid = table_data.to;
    call_data.charm = gift_price * gift_count;

    frame_tools:call_event("update_gift_charm", call_data);
end

--
function frame_layer:on_frame_game_gift_ret(table_data)
    if table_data == nil then return; end

    if table_data.flag == 0 then return;end

    if table_data.msg == nil then return;end

    frame_tools:show_hinting(frame_tools:gbk_to_utf8(table_data.msg));
end

--
function frame_layer:on_frame_game_award_ret(table_data)
    frame_tools:add_test_win_text("on_frame_game_award_ret:"..table_data.type)
    if table_data == nil then return; end

    if table_data.flag == 0 then
        if table_data.type == 1 then
            frame_logic:award_count_change(1);
        end
    end

end

--
function frame_layer:on_frame_game_user_come(table_data)
    if table_data == nil then return; end

    local user_id = table_data.userid or 0;
    local head_frame_id = table_data.headframeid or 0;

    frame_logic:set_user_head_frame_id(user_id, head_frame_id);
end
-----------------------------------------------------------------------------------------------------------------------
--
--设置背景
function frame_layer:init_bg_img()
    local index = 0;
    if Frame_Config_Win and Frame_Config_Win.game_id then
        index = tonumber(frame_tools:get_config_value("frame_bg_select_"..Frame_Config_Win.game_id, "1") );
    end
    
    if index == 0 then
        return;
    end
    if Frame_Config_Win.bg_config and Frame_Config_Win.bg_config[index] and Frame_Config_Win.bg_config[index].bg then
        self:set_bg_img(Frame_Config_Win.bg_config[index].bg);
    else 
        index = 0;
    end
    self._bg_index = index;
end
--设置背景
function frame_layer:set_bg_img(str_path)
    if self.bg_img == nil then
        self.bg_img = ImageView:create();
        self.bg_layout:addChild(self.bg_img, -1);
        self.bg_img:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height/2));
    end

    self.bg_img:loadTexture(str_path);
    self.bg_img:setVisible(true);
end

--打开设置
function frame_layer:open_config_win(win_type)
    if self.config_win ~= nil then
        self.config_win:show_window(true);
        return;
    end

    if win_type == 2 then
        local table_data = {};
        if win_type == 2 then
            table_data = Frame_Config_Win;

            if table_data.bg_count == nil or table_data.bg_count <= 1 then
                win_type = 1
            end
        end

        if self._bg_index == nil or self._bg_index == 0 then
            self._bg_index = 1;
        end

        self.config_win = frame_config_win_2:new();
        self.config_win:init(table_data, function(index) self:on_btn_select_bg(index) end);
        self.config_win:set_switch_bg(self._bg_index);
    else
        self.config_win = frame_config_win:new();
        self.config_win:init();
    end
    
    self.window_layout:addChild(self.config_win);
    self.config_win:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height/2));
    self.config_win:show_window(true);
end

--打开提示
function frame_layer:open_hint_win(table_data)
    if self.hint_win == nil then
        self.hint_win = frame_hint_win:new()
        self.hint_win:init();

        self.window_layout:addChild(self.hint_win);
        self.hint_win:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height/2));
    end
    self.hint_win:set_data(table_data);
    self.hint_win:show_window(true);
end

--打开自己的个人信息
function frame_layer:open_self_user_info()
    if self.user_info_self == nil then
        self.user_info_self = frame_user_info_self:new();
        self.window_layout:addChild(self.user_info_self);
        self.user_info_self:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height/2))
        self.user_info_self:init(frame_logic:get_game_id());
    end 
    local user_data = frame_logic:get_self_user_data();
    self.user_info_self:set_user_data(user_data);
    self.user_info_self:show_window(true);
end

--打开他人的个人信息
function frame_layer:open_other_user_info_with_chair(chair_id)
    if self.user_info_other == nil then
        self.user_info_other = frame_user_info_other:new();
        self.window_layout:addChild(self.user_info_other);
        self.user_info_other:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height/2))
        self.user_info_other:init(frame_logic:get_gift_info());
    end 
    local user_data = frame_logic:get_user_data(chair_id);
    self.user_info_other:set_user_data(user_data);
    self.user_info_other:show_window(true);
end

--打开他人的个人信息
function frame_layer:open_other_user_info_with_userid(user_id)
    if self.user_info_other == nil then
        self.user_info_other = frame_user_info_other:new();
        self.window_layout:addChild(self.user_info_other);
        self.user_info_other:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height/2))
        self.user_info_other:init(frame_logic:get_gift_info());
    end 
    local user_data = frame_logic:get_user_data_with_userid(user_id);
    if user_data == nil then print("frame_log:do not find user data when open user info window"); end
    self.user_info_other:set_user_data(user_data);
    self.user_info_other:show_window(true);
end

--打开聊天窗口
function frame_layer:open_chat_left_win()
    if self.chat_win_left == nil then
        self.chat_win_left = frame_chat_left_win:new();
        self.window_layout:addChild(self.chat_win_left);
        self.chat_win_left:init();
        self.chat_win_left:set_text_list(self.m_char_str_list);   
    end
    if self.chat_win_left:isVisible() == true then return;end

    self.chat_win_left:setPosition(ccp(-240, self.visibleSize.height/2))

    self.chat_win_left:show_window(true, false); 
    self.chat_win_left:stopAllActions();
    self.chat_win_left:runAction(CCMoveTo:create(0.2, ccp(self.m_screenGap + 240, self.visibleSize.height/2)) );
end

function frame_layer:open_chat_right_win()
    if self.chat_win_right == nil then
        self.chat_win_right = frame_chat_right_win:new();
        self.window_layout:addChild(self.chat_win_right);
        self.chat_win_right:init();
        self.chat_win_right:set_text_list(self.m_char_str_list);
    end
    if self.chat_win_right:isVisible() == true then return;end

    self.chat_win_right:setPosition(ccp(self.visibleSize.width + 240, self.visibleSize.height/2))

    self.chat_win_right:show_window(true, false);  
    self.chat_win_right:stopAllActions();
    self.chat_win_right:runAction(CCMoveTo:create(0.2, ccp(self.visibleSize.width - self.m_screenGap - 240, self.visibleSize.height/2) ) );
end
--关闭聊天窗口
function frame_layer:close_chat_win()
    if self.chat_win_left then
        local array = CCArray:create();
        array:addObject(CCMoveTo:create(0.2, ccp(-240, self.visibleSize.height/2) ) );
        array:addObject(CCCallFunc:create(function() self.chat_win_left:show_window(false, false); end ) );
        self.chat_win_left:stopAllActions();
        self.chat_win_left:runAction(CCSequence:create(array ) );
    end
    if self.chat_win_right then
        local array = CCArray:create();
        array:addObject(CCMoveTo:create(0.2, ccp(self.visibleSize.width + 240, self.visibleSize.height/2) ) );
        array:addObject(CCCallFunc:create(function() self.chat_win_right:show_window(false, false); end ) );
        self.chat_win_right:stopAllActions();
        self.chat_win_right:runAction(CCSequence:create(array ) );
    end
end
--打开任务
function frame_layer:open_task_win(scale,game_id)
    if self.task_win == nil then
        self.task_win = frame_task_win:new();
        self.task_win:init();
        self.window_layout:addChild(self.task_win);
        self.task_win:setAnchorPoint(ccp(0.5,0))
    end
    self.task_win:setScale(scale);
    self.task_win:setPosition(ccp(self.m_screenGap + 170*scale, self.visibleSize.height/2))
    self.task_win:show_task(game_id);
end
--关闭任务
function frame_layer:close_task_win()
    if self.task_win then
        self.task_win:show_window(false, false);
    end
end
--打开退出提示框
function frame_layer:open_exit_win(exit_callback)
    if self.exit_win == nil then
        self.exit_win = frame_exit_win:new();
        self.window_layout:addChild(self.exit_win);
        self.exit_win:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height/2))
        self.exit_win:init();
    end
    self.exit_win:set_exit_callback(exit_callback);
    self.exit_win:set_change_data(frame_logic:get_self_data_changed());
--    self.exit_win:update_task(228);     
    local game_status = frame_logic:get_game_status();
    if game_status == FRAME_USER_STATUS.US_PLAY then
        self.exit_win:set_type(3);
    else
        self.exit_win:set_type(2);
    end
    self.exit_win:update_task(frame_logic:get_game_id()); 
    self.exit_win:show_window(true);
end
--打开个人举报窗口
function frame_layer:open_single_report_win(userid, name)
    if self.single_report_win == nil then
        self.single_report_win = frame_report_win_single:new();
        self.single_report_win:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height/2))
        self.window_layout:addChild(self.single_report_win);
        self.single_report_win:init();
    end 
    self.single_report_win:clear();
    self.single_report_win:set_name(name);
    self.single_report_win:set_userid(userid);
    self.single_report_win:show_window(true);
end
--打开举报窗口
function frame_layer:open_report_win()
    if self.report_win == nil then
        self.report_win = frame_report_win:new();
        self.window_layout:addChild(self.report_win);
        self.report_win:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height/2))
        self.report_win:init();
    end
    local user_data = {}; 
    local all_user_data = frame_logic:get_all_user_data();
    for i=1,#all_user_data do
        if i - 1 ~= frame_logic:get_self_chair() and next(all_user_data[i]) ~= nil then
            table.insert(user_data, all_user_data[i]);
        end
    end
    self.report_win:set_user_item(user_data);
    self.report_win:show_window(true);
end

--设置聊天和表情位置
function frame_layer:init_chat_play(data)
    self.chat_play:init_chat_play(data);
end

--
function frame_layer:init_game_chat(str_list)
    self.chat_play:set_chat_list(str_list);

    self.m_char_str_list = str_list;
    if self.chat_win_left then
        self.chat_win_left:set_text_list(self.m_char_str_list);   
    end
    if self.chat_win_right then
        self.chat_win_right:set_text_list(self.m_char_str_list);   
    end
end

--
function frame_layer:init_gift_pos(pos)
    self.gift_play:init_gift_pos(pos);
end

--
function frame_layer:show_chat(index, chat_id)
    if chat_id < 1000 then
        self.chat_play:show_chat_text(index, chat_id);
    else
        self.chat_play:show_emotion_ani(index, chat_id - 1000);
    end
end

--
function frame_layer:play_gift(from_id, to_id, gift_id, gift_num, scale)
    self.gift_play:play_gift_times(from_id, to_id, gift_id, gift_num, scale);
end

--获取救济金
function frame_layer:get_relief_gold()
    local alms_data = frame_logic:get_alms_data();
    if alms_data.threshold <= frame_logic:get_self_all_gold() then
        return false;
    end
    
    local limit = alms_data.total - alms_data.times;
    if limit > 0 then
        local send_data = {};
        send_data.type = 1;

        frame_tools:send_data(FRAME_MESSAGE.SUB_GAME_OBTAIN_AWARD, send_data);
        return true;
    end
    return false;
end
--使用救济金卡（1/初级,2/高级）
function frame_layer:get_relief_gold_card(typeid)
    local alms_data = frame_logic:get_alms_data();
    if alms_data.threshold <= frame_logic:get_self_all_gold() then
        return false;
    end
    if typeid == 1 then
        local card_count = frame_tools:get_prop_count_by_id(FRAME_USER_PROP_ID.relief_crad) or 0;
        if card_count > 0 then
            local send_data = {};
            send_data.type = 2;
    
            frame_tools:send_data(FRAME_MESSAGE.SUB_GAME_OBTAIN_AWARD, send_data);
            return true;
        end 
    elseif typeid == 2 then
        local pro_card_count = frame_tools:get_prop_count_by_id(FRAME_USER_PROP_ID.relief_crad_pro) or 0;
        if pro_card_count > 0 then
            local send_data = {};
            send_data.type = 3;
    
            frame_tools:send_data(FRAME_MESSAGE.SUB_GAME_OBTAIN_AWARD, send_data);
            return true;
        end 
    end
    
    return false;
end

--打开金币不足窗口
function frame_layer:open_broke_win()
    if frame_tools:is_score_kind() then return; end
    

    if self.broke_win == nil then
        self.broke_win = frame_broke_win:new();
        self.broke_win:init(frame_logic:get_topup())
        self.window_layout:addChild(self.broke_win);
        self.broke_win:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height/2))
    end

--    local win_type = 1;
--    if bit._and(frame_tools:get_module_mask(), FRAME_MASK_MODULE.MASK_MODULE_SHOP) <= 0 then
--        win_type = 2;
--    end

    local alms_data = frame_logic:get_alms_data();
    local card_count = frame_tools:get_prop_count_by_id(FRAME_USER_PROP_ID.relief_crad) or 0;
    local pro_card_count = frame_tools:get_prop_count_by_id(FRAME_USER_PROP_ID.relief_crad_pro) or 0;
--    self.broke_win:set_type(win_type);
    self.broke_win:set_card_count(card_count, pro_card_count);
    self.broke_win:set_relief_data(alms_data);
    self.broke_win:show_broke_win(true);
end
--
function frame_layer:close_broke_win_with_gold_up()
    if self.broke_win == nil then  return; end

    -- 金币检查
    local user_gold = frame_logic:get_self_all_gold();
    local alms_data = frame_logic:get_alms_data();

    if user_gold < alms_data.threshold then
        return;
    end

    if self.broke_win:isVisible() == true then
        self.broke_win:show_broke_win(false);
    end
end
--
function frame_layer:start_test_win()
    --
    if self.frame_test_win == nil then
        self.frame_test_win = frame_test_win:new()
        self.main_layer:addChild(self.frame_test_win, 6);
        self.frame_test_win:init();
        self.frame_test_win:setPosition(ccp(170,160));
    end
end
--
function frame_layer:add_test_win_text(text)
    if self.frame_test_win then
        self.frame_test_win:add_text(text);
    end
end
---------------------------------------------------------------------------------------
--
---------------------------------------------------------------------------------------
function frame_layer:on_btn_select_bg(index)
    local bg_path = Frame_Config_Win.bg_config[index].bg;
    self:set_bg_img(bg_path);

    frame_tools:set_config_value("frame_bg_select_"..Frame_Config_Win.game_id, tostring(index) ); 
end





---------------------------------------------------------------------------------------
--
---------------------------------------------------------------------------------------
function frame_layer:__update()
    local windows_array = self.window_layout:getChildren();
    local win_count = windows_array:count();

    for i=0,win_count-1 do 
        local win = windows_array:objectAtIndex(i);
        if win.__update then
            win:__update();
        end
    end

    self.game_layer:__update();
    frame_tools:__update();
end

--endregion
