--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

frame_logic = class("frame_logic");

function frame_logic:ctor(...)
--    self:init(...);
end

function frame_logic:init_data()
    self.m_user_count = 0;
    self.m_self_chair_id = -1;
    self.m_self_user_id = 0;

    self.m_start_self_data = nil
    self.m_room_data = nil

    self.m_gift_info = {-1,-2,-5,1,2};
    self.m_topup = 0;

    --游戏状态
    self.m_game_status = 0;
    --救济金
    self.m_alms_data = {};
    --初始数据（金币，积分，魅力值）
    self.m_original_data = {};
    --
    self.m_once_win_lost = {};
    --
    self.m_game_list = {};
end

function frame_logic:init()
    self:init_data();

    self.m_room_data = frame_tools:get_room_data();
    self.m_user_count = self.m_room_data.chair_count;
    self.m_game_id = self.m_room_data.game_id;

    self:__read_gift_info(self.m_room_data.rule);
    local  topop = self:__read_topup_info(self.m_room_data.rule);
    if topop ~= nil then
        self.m_topup = tonumber(topop);
    end

    self.m_user_data = {};
    for i = 1, self.m_user_count do
        table.insert(self.m_user_data, {});
    end
    
    self:load_game_list();
end
--
function frame_logic:load_game_list()
    if frame_tools:is_func("get_game_list") == false then return;end
    if frame_tools:is_func("get_game_list_data") == false then return;end
    if bit._and(frame_tools:get_module_mask(), FRAME_MASK_MODULE.MASK_MODULE_GAMELIST) <= 0 then return; end

    local game_list = frame_tools:get_game_list();
    if game_list == nil or next(game_list) == nil then return;end

    for k,v in pairs(game_list) do
        for k1,v1 in pairs(v.list) do
            if v1 ~= nil then
                table.insert(self.m_game_list, v1);
            end
        end 
    end

end

--
function frame_logic:get_game_list()
    return self.m_game_list;
end

--
function frame_logic:find_game_list(game_id)
    for k,v in pairs(self.m_game_list) do
        if v == game_id then
            return true;
        end
    end

    return false;
end

--
function frame_logic:set_game_status(game_status)
    if game_status and game_status ~= self.m_game_status then
        local data = {};
        data.old = self.m_game_status;
        data.new = game_status;
        frame_tools:call_event("update_game_status", data);
    end
    self.m_game_status = game_status or 0;
end
--
function frame_logic:get_game_status()
    return self.m_game_status;
end
--
function frame_logic:is_score_kind()
    if bit._and(self.m_room_data.room_kind, FRAME_ROOM_KIND.ROOM_KIND_SCORE) > 0 then
        return true;
    end

    return false;
end
--
function frame_logic:set_alms_data(alms_data)
    if alms_data == nil then return; end
    self.m_alms_data = alms_data;
end
--
function frame_logic:award_count_change(change)
    if self.m_alms_data == nil then return;end
    if self.m_alms_data.times == nil then return;end

    self.m_alms_data.times = self.m_alms_data.times + change;
end
--
function frame_logic:set_original_data(data)
    if data == nil then return; end
    self.m_original_data = data;
end
--
function frame_logic:get_alms_data()
    if self.m_alms_data == nil then return {}; end;
    return self.m_alms_data;    
end
--
function frame_logic:get_self_gold()
    local data = self:get_self_user_data();
    if data == nil then return;end

    return data.gold;
end
--
function frame_logic:get_self_all_gold()
    local data = self:get_self_user_data();
    if data == nil then return;end

    local bank = self.m_alms_data.bank or 1000000;
    return data.gold + bank;
end
--
function frame_logic:get_gift_info()
    return self.m_gift_info;
end

function frame_logic:get_game_id()
    return self.m_game_id;
end

function frame_logic:get_chair_count()
    return self.m_room_data.chair_count;
end

function frame_logic:get_topup()
    return self.m_topup;
end

function frame_logic:get_chair_id_with_userid(userid)
    if userid == nil then return;end
    if self.m_user_data == nil then return end;
    for k,v in pairs(self.m_user_data) do
        if v.user_id == userid then
            return v.chair_id;
        end
    end

    return -1;
end

function frame_logic:set_user_win_lose(table_data)
    if table_data == nil then return;end
    
    self.m_once_win_lost = table_data;
end

function frame_logic:get_user_win_lose(userid)
    if self.m_once_win_lost == nil then return;end
    local gold = self.m_once_win_lost.gold_change or {};
    local userid_list = self.m_once_win_lost.userid or {};
    for k,v in pairs(userid_list) do
        if v == userid then
            return gold[k];
        end
    end
end
--
function frame_logic:set_user_head_frame_id(userid, head_frame_id)
    if self.m_user_data == nil then return; end
    for k,v in pairs(self.m_user_data) do
        if v.user_id == userid then
            v.head_frame = head_frame_id;
        end
    end
end
--
function frame_logic:set_user_data(chair_id, user_data)
    if user_data == nil then return end;
    --进房间时自己的数据
    if self.m_self_chair_id == -1 then
        self.m_self_chair_id = chair_id;
        self.m_self_user_id = user_data.user_id;
        self.m_start_self_data = user_data;
    end

    self.m_user_data[chair_id + 1] = user_data;

    if chair_id == self.m_self_chair_id then
        local change_data = self:get_self_data_changed();
        frame_tools:call_event("update_self_change", change_data);
    end
end
--获取变化量（金币，魅力，积分）
function frame_logic:get_self_data_changed()
    local change_data = { charm = 0, gold = 0, score = 0, };
    if self.m_user_data == nil then return change_data;end;
    if self.m_self_chair_id == -1 then return change_data;end;
    if self.m_user_data[self.m_self_chair_id + 1] == nil then return change_data;end;
    if self.m_original_data == nil or next(self.m_original_data) == nil then return change_data;end;

    change_data.charm = self.m_user_data[self.m_self_chair_id + 1].charm - self.m_original_data.charm;
    change_data.gold = self.m_user_data[self.m_self_chair_id + 1].gold - self.m_original_data.gold;
    change_data.score = self.m_user_data[self.m_self_chair_id + 1].socre - self.m_original_data.score;

    return change_data;
end

function frame_logic:get_self_chair()
    return self.m_self_chair_id;
end

function frame_logic:get_self_user_id()
    return self.m_self_user_id;
end

function frame_logic:get_all_user_data()
    if self.m_user_data == nil then return end;
    return self.m_user_data;
end

function frame_logic:get_user_data(chair_id)
    if self.m_user_data == nil then return end;
    if self.m_user_data[chair_id + 1] == nil then return end;
    return self.m_user_data[chair_id + 1];
end

function frame_logic:get_self_user_data()
    if self.m_user_data == nil then return end;
    if self.m_user_data[self.m_self_chair_id + 1] == nil then return end;
    return self.m_user_data[self.m_self_chair_id + 1];
end

function frame_logic:get_user_data_with_userid(userid)
    if self.m_user_data == nil then return; end
    for k,v in pairs(self.m_user_data) do
        if v.user_id == userid then
            return v;
        end
    end
end

function frame_logic:__read_gift_info(rule)
    local str_rule = rule;
    local gift_index = string.find(str_rule, "gift_cost", 1);
    if gift_index == nil then return end
    local gift_index_2 = string.find(str_rule, ";", gift_index);
    if gift_index_2 == nil then return end

    local str_gift = string.sub(str_rule, gift_index, gift_index_2);
    local begin_index = string.find(str_gift, "\"", 1);
    if begin_index == nil then return end
    local end_index = string.find(str_gift, "\"", begin_index + 1);
    if end_index == nil then return; end

    self.m_gift_info = {};
    local point_index = nil;
    repeat
        point_index = string.find(str_gift, ",", begin_index + 1);
        if point_index == nil then
            point_index = end_index;
        end
        local gift_item = string.sub(str_gift, begin_index + 1, point_index - 1);
        table.insert(self.m_gift_info, tonumber(gift_item) );        
        begin_index = point_index;

    until(begin_index >= end_index);
end

function frame_logic:__read_topup_info(rule)
    local str_rule = rule;
    local topup_index = string.find(str_rule, "topup", 1);
    if topup_index == nil then return end
    local topup_index_2 = string.find(str_rule, ";", topup_index);
    if topup_index_2 == nil then return end

    local str_aim = string.sub(str_rule, topup_index, topup_index_2);

    local begin_index = string.find(str_aim, "\"", 1);
    local end_index = string.find(str_aim, "\"", begin_index + 1);

    local str_topup = string.sub(str_aim, begin_index + 1, end_index - 1);
    return str_topup
end



return frame_logic;

--endregion
