--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
local cjson = require "cjson"

frame_tools = {};

function frame_tools:ctor(...)

end

function frame_tools:init(frame_layer, visibleSize)
    self.frame_layer = frame_layer;

    self.frame_event_switch = frame_event_switch:new();
    self.frame_event_switch:init();

    self.m_visibleSize = visibleSize;
    
    self:__init_finc_table();

    self.m_chat_wait_clock = 0;
    self.m_chat_time = 0;
end

function frame_tools:__update()
    if self.m_chat_wait_clock > 0 then
        self.m_chat_wait_clock = self.m_chat_wait_clock - 1;
    elseif self.m_chat_wait_clock < 0 then
        self.m_chat_wait_clock = 0;
    end
end

--获取窗口大小
function frame_tools:get_visibleSize()
    return self.m_visibleSize;
end
--初始化函数查询列表
function frame_tools:__init_finc_table()
    self.func_table = {};
    self.func_table["show_simple_shop"] = show_simple_shop;
    self.func_table["on_do_task"] = on_do_task;
    self.func_table["get_game_list_data"] = get_game_list_data;
    self.func_table["get_game_list"] = get_game_list;
    self.func_table["show_shop"] = show_shop;
    self.func_table["show_game_grade"] = show_game_grade;
    self.func_table["bpversion"] = bpversion;
    self.func_table["get_self_table_id"] = get_self_table_id;
    self.func_table["share_wechat_image	"] = share_wechat_image;
    self.func_table["share_wechat_program"] = share_wechat_program;
    self.func_table["share_private_wechat"] = share_private_wechat;
    self.func_table["share_wechat"] = share_wechat;
    self.func_table["get_module_mask"] = get_module_mask;
    self.func_table["get_module_mask2"] = get_module_mask;
    self.func_table["get_pay_mask"] = get_pay_mask;
    self.func_table["set_bugle_custom"] = set_bugle_custom;
    self.func_table["show_bugle_send"] = show_bugle_send;
    self.func_table["get_string_count"] = get_string_count;
    self.func_table["show_message_box"] = show_message_box;
end
--查询函数是否存在
function frame_tools:is_func(str_name)
    if self.func_table[str_name] then 
        return true;
    end

    return false;
end
-----------------------------------------------------------------------------------------------------------
--c++接口
--获取viewid
function frame_tools:switch_to_view_id(param_chairid)
    local view_id = switch_to_view_id(param_chairid)
	return view_id
end
--获取chairid
function frame_tools:switch_to_chair_id(param_viewid)
    return switch_to_chair_id(param_viewid)
end
--获取自己的chairid
function frame_tools:get_self_chair_id()
    if get_self_chair_id then
        return get_self_chair_id();
    else
        frame_logic:get_self_chair();
    end
    return -1;
end
--暂停消息
function frame_tools:pause_message()
    pause_message();
end
--恢复消息
function frame_tools:restore_message()
    restore_message()
end
--发送数据
function frame_tools:send_data(param_id, param_data)
    local str_data = cjson.encode(param_data)
    send_data(param_id,str_data)
end
--发送聊天数据
function frame_tools:send_user_chat_data(send_data)
    if self.m_chat_wait_clock > 0 then
        self:show_hinting("您的发言过快，请稍后再发哟");
        return;
    end
    self:send_data(FRAME_MESSAGE.SUB_GAME_CHAT, send_data);

    self.m_chat_wait_clock = self.m_chat_time;
end
--发送准备
function frame_tools:send_ready_data()
    send_ready_data();
end
--站起
function frame_tools:stand_up()
    stand_up();
end
--坐下
function frame_tools:sit_down(table_id, chair_id)
    if table_id == nil or chair_id == nil then
        sit_down()
    else
        sit_down(table_id, chair_id)
    end
end
--换座
function frame_tools:re_sit_down(table_id, chair_id)
    if table_id == nil or chair_id == nil then
        re_sit_down()
    else
        re_sit_down(table_id, chair_id)
    end
end
--用于完成重新进入房间操作
function frame_tools:re_enter_game()
    re_enter_game();
end
--离开游戏
function frame_tools:leave_game()
    leave_game();
end
--关闭游戏
function frame_tools:close_game()
    close_game();
end
--判断当前是否为旁观模式
function frame_tools:is_look_mode()
    return is_look_mode();
end
--判断是否允许旁观
function frame_tools:is_allow_look()
    return is_allow_look();
end
--获取游戏状态
function frame_tools:get_game_status()
    return get_game_status(); 
end
--设置游戏状态
function frame_tools:set_game_status(param_status)
    set_game_status(param_status);
end
--获取游戏信息
--返回说明:  table型 {"game_id":0,"game_name":0,"online_count":0,"min_version":0,"max_version":0}
function frame_tools:get_game_data()
    local game_data = clone(frame_game_data);
    local data = get_game_data();
    local table_json ={};
    if data ~= nil and data ~= "" then
        table_json = cjson.decode(data); 
    end

    for k,v in pairs(table_json) do
        if v ~= nil then 
            game_data[k] = v;
        end
    end
    return game_data;
end
--获取房间信息
--返回说明:  table型 
--{"room_id":0,"room_name":0,"online_count":0,"address":"127.0.0.1","port":1002,"game_id":0,"room_mode":0,"room_kind":0,"limit_mask":0,
--"min_score":0,"max_score":0,"min_gold":0,"max_gold":0,"min_charm":0,"max_charm":0,"rule":"b=2;c=4;gift=1000,2000,3000,5000;",
--"game_genre":0,"table_count":0,"chair_count":0,"game_version":0}
function frame_tools:get_room_data()
    local room_data = clone(frame_room_data);
    local data = get_room_data();
    local table_json ={};
    if data ~= nil and data ~= "" then
        table_json = cjson.decode(data); 
    end

    for k,v in pairs(table_json) do
        if v ~= nil then 
            room_data[k] = v;
        end
    end

    return room_data;
end
--获取指定chairid用户信息
--返回说明:  table型 
--{"face_id":0,"sex":0,"member":0,"user_id":0,"group_id":0,"user_right":0,"master_right":0,"nickname":"lilei","gold":0,"
--socre":0,"win_count":0,"lose_count":0,"draw_count":0,"flee_count":0,"exp":0,"table_id":0,"chair_id":0,"delay":0,"user_status":0,"game_time":0
--praise:0,charm:0}
function frame_tools:get_user_data(chair_id)
    local user_data = clone(frame_user_data);
    local data = get_user_data(chair_id);
    local table_json ={};
    if data ~= nil and data ~= "" then
        table_json = cjson.decode(data); 
    end

    if table_json.nickname ~= nil then
        table_json.nickname = self:gbk_to_utf8(table_json.nickname);
    end

    for k,v in pairs(table_json) do
        if v ~= nil then 
            user_data[k] = v;
        end
    end
    
    return user_data;
end
--获取指定userid的用户信息
--返回说明:  table型 同上
--{"face_id":0,"sex":0,"member":0,"user_id":0,"group_id":0,"user_right":0,"master_right":0,"nickname":"lilei","gold":0,"
--socre":0,"win_count":0,"lose_count":0,"draw_count":0,"flee_count":0,"exp":0,"table_id":0,"chair_id":0,"delay":0,"user_status":0,"game_time":0
--praise:0,charm:0}
function frame_tools:get_user_data_by_user_id(user_id)
    local user_data = clone(frame_user_data);
    local data = get_user_data_by_user_id(user_id);
    local table_json ={};
    if data ~= nil and data ~= "" then
        table_json = cjson.decode(data); 
    end

    if table_json.nickname ~= nil then
        table_json.nickname = self:gbk_to_utf8(table_json.nickname);
    end

    for k,v in pairs(table_json) do
        if v ~= nil then 
            user_data[k] = v;
        end
    end
    
    return user_data;
end
--获取自己的用户信息
--返回说明:  table型 同上
--{"face_id":0,"sex":0,"member":0,"user_id":0,"group_id":0,"user_right":0,"master_right":0,"nickname":"lilei","gold":0,"
--socre":0,"win_count":0,"lose_count":0,"draw_count":0,"flee_count":0,"exp":0,"table_id":0,"chair_id":0,"delay":0,"user_status":0,"game_time":0
--praise:0,charm:0}
function frame_tools:get_self_user_data()
    local user_data = clone(frame_user_data);
    local data = get_self_user_data();
    local table_json ={};
    if data ~= nil and data ~= "" then
        table_json = cjson.decode(data); 
    end

    if table_json.nickname ~= nil then
        table_json.nickname = self:gbk_to_utf8(table_json.nickname);
    end

    for k,v in pairs(table_json) do
        if v ~= nil then 
            user_data[k] = v;
        end
    end
    
    return user_data;
end
--获取自己的userid
function frame_tools:get_self_user_id()
    if get_self_user_id then
        return get_self_user_id();
    else 
        return frame_logic:get_self_user_id();
    end
    
    return 0;
end
--获取自己的元宝
function frame_tools:get_self_ingot()
    if get_self_ingot then
        return get_self_ingot();
    end

    return 0;
end
--获取指定道具的过期时间
function frame_tools:get_status_time_by_id(prop_id)
    if get_status_time_by_id then
        return get_status_time_by_id(prop_id);
    end
end
--设置指定道具的过期时间
function frame_tools:set_status_time_by_id(prop_id, time)
    if set_status_time_by_id then
        set_status_time_by_id(prop_id, time);
    end
end

--用于判断指定的道具是否在有效期内
function frame_tools:get_prop_status(prop_id)
    if get_prop_status then
        return get_prop_status(prop_id);
    end
end

--函数描述:  用于格式化字符串(会替换指定关键字为具体的内容，{KINDID}等会替换为真实的数值，如107)
--参数说明:  string型 需格式化的字符串
--返回说明:  string型 格式化后的字符串
function frame_tools:make_url(str_data)
    if make_url then
        return make_url(str_data);
    end
end
--在本地的数据库中执行指定的SQL脚本
function frame_tools:execute_sql(str_sql)
    if execute_sql then
        execute_sql(str_sql)
    end
end
--获取指定道具的信息
--参数说明:  int型 道具ID
--返回说明:  tanle型 道具信息 {"id":1002,"type":2,"name":"奖券","caption":"可用于兑换话费或实物奖励","can_sale":0,"can_use":0}
function frame_tools:get_prop_data_by_id(prop_id)
    local prop_data = clone(frame_prop_data);
    local data = get_prop_data_by_id(prop_id);
    local table_json ={};
    if data ~= nil and data ~= "" then
        table_json = cjson.decode(data); 
    end

    for k,v in pairs(table_json) do
        if v ~= nil then 
            prop_data[k] = v;
        end
    end

    return prop_data;
end
--获取指定道具的数量
function frame_tools:get_prop_count_by_id(prop_id)
    if get_prop_count_by_id then
        return get_prop_count_by_id(prop_id);
    end
end
--设置指定道具的信息
function frame_tools:set_prop_count_by_id(prop_id, count)
    if set_prop_count_by_id then
        return set_prop_count_by_id(prop_id, count);
    end
end 
--显示商城
function frame_tools:show_shop(id)
    if show_shop then
        show_shop(id);
    end
end
--显示C++大厅设置
function frame_tools:show_setting()
    if show_setting then
        show_setting();
    end
end
--显示下拉提示
function frame_tools:show_hinting(str_hint)
    if show_hinting then
        show_hinting(str_hint);
    end
end
--显示加载动画
function frame_tools:show_loading(nID)
    if show_loading then
        show_loading(nID);
    end
end
--显示简易商场，如有商场管控，则显示提示，提示内容为 str_title
function frame_tools:show_simple_shop(str_title, str_btn)
    if type(str_title) ~= type("") then
        str_title = "";
    end
    if type(str_btn) ~= type("") then
        str_btn = "";
    end
    if show_simple_shop and bit._and(self:get_module_mask(), FRAME_MASK_MODULE.MASK_MODULE_SHOP) > 0 then 
        show_simple_shop(str_title, str_btn);
    else
        frame_tools:show_hinting(str_title);
    end
end

--MD5加密
function frame_tools:string_md5(str_data)
    return string_md5(str_data);
end

--str_path,需加密文件的路径
function frame_tools:file_md5(str_path)
    return file_md5(str_path);
end
--
function frame_tools:gbk_to_utf8(str_gbk)
    return gbk_to_utf8(str_gbk);
end
--
function frame_tools:utf8_to_gbk(str_utf8)
    return utf8_to_gbk(str_utf8);
end
--获取当前电量
function frame_tools:get_curr_battery()
    if get_curr_battery then
        return get_curr_battery();
    else   
        return 100;
    end
end
--获取当前时间
--返回table型 {"year":1999,"month":12,"day":25,"week":2,"hour":23,"minute":59,"second":59,"millisecond":232132122}
function frame_tools:get_current_time()
    if get_current_time then
        return cjson.decode(get_current_time());
    end
    local nowTime ={}
    nowTime.year = tonumber(os.date("%Y"));
    nowTime.month = tonumber(os.date("%m"));
    nowTime.day = tonumber(os.date("%d"));
    nowTime.week = tonumber(os.date("%w"));
    nowTime.hour = tonumber(os.date("%H"));
    nowTime.minute = tonumber(os.date("%M"));
    nowTime.second = tonumber(os.date("%S"));

    return nowTime;
end
--获取wifi状态
function frame_tools:get_wifi_status()
    if get_wifi_status then
        return get_wifi_status();
    end
end
--获取udid
function frame_tools:get_udid()
    if get_udid then
        return get_udid();
    end
end
--获取缓存路径
function frame_tools:get_cache_path()
    if get_cache_path then
        return get_cache_path()
    end
end
--获取系统文档路径
function frame_tools:get_document_path()
    if get_document_path then
        return get_document_path();
    end
end
--替换字符串中字符
--参数说明:  string型 替换前的字符串
--参数说明:  string型 需替换的键名
--参数说明:  string型 需替换的键值
--返回说明:  string型 替换后的字符串
function frame_tools:string_replace_key(str_input, str_key, str_value)
    if string_replace_key then
        return string_replace_key(str_input, str_key, str_value);
    else
        string.gsub(str_input, str_key, str_value)
    end
    return str_input;
end
--替换字符串中数字
--参数说明:  string型 替换前的字符串
--参数说明:  string型 需替换的键名
--参数说明:  int型 需替换的键值
--返回说明:  string型 替换后的字符串
function frame_tools:string_replace_key_with_integer(str_input, str_key, int_value)
    if string_replace_key_with_integer then
        return string_replace_key_with_integer(str_input, str_key, str_value);
    else
        string.gsub(str_input, str_key, tostring(int_value))
    end
    return str_input;
end

--获取设备名称
function frame_tools:get_device_name()
    if get_device_name then
        return get_device_name();
    end
end
--获取电话号码
function frame_tools:get_phone_number()
    if get_phone_number then
        return get_phone_number();
    end
end

--用于判断指定包名应用是否有安装在手机中
function frame_tools:get_install_status(str_name)
    if get_install_status then
        return get_install_status(str_name);
    end
end
--打开链接
function frame_tools:open_url(str_addr)
    if open_url then
        return open_url(str_addr);
    end
end
--微信分享
--参数说明:  string型 分享标题
--参数说明:  string型 分享内容
--参数说明:  string型 分享图标的路径
--参数说明:  string型 分享连接的地址
--参数说明:  int型 	分享类型 0:好友 1:朋友圈
--返回说明:  int型 	0:失败 1:成功
function frame_tools:share_wechat(str_title, str_content, str_img_path, str_addr, int_type)
    if share_wechat then
        return share_wechat(str_title, str_content, str_img_path, str_addr, int_type);
    end

    return 0;
end
--好友房微信分享
--参数说明: string   标题
--参数说明: string   房间号
--参数说明: function    回调函数
function frame_tools:share_private_wechat(str_title, str_roomid, callback)
    if share_private_wechat then
        return share_private_wechat(str_title, str_roomid, callback);
    end

    return 0;
end
--微信分享，分享小程序卡片
--参数说明:	string  标题  
--参数说明:	string  正文
--参数说明:	string   url  不填为默认
--参数说明:	stirng   图片绝对路径，不填为默认
--参数说明:	string   小程序参数  如："?version={version}"
--参数说明:	int  	 分享地址，朋友or朋友圈
--参数说明:	function	回调函数
--返回说明:  int  分享行为是否ok
function frame_tools:share_wechat_program(str_title, str_content, str_url, str_img_path, str_param, int_type, callback)
    if share_wechat_program then
        return share_wechat_program(str_title, str_content, str_url, str_img_path, str_param, int_type, callback)
    end
    return 0;
end
--微信分享图片
--参数说明:  sting    图片绝对路径
--参数说明:  int       分享类型
--参数说明:  function  回调函数
--返回说明:  int   分享行为是否ok
function frame_tools:share_wechat_image(str_img_path, int_type, callback)
    if share_wechat_image then
        return share_wechat_image(str_title, str_content, str_url, str_img_path, str_param, int_type, callback)
    end
    return 0;
end
--显示奖励动画
--参数说明:  table结构 {"resdata":{"prop_award":[{"id":1,"cnt":1}],"status_award":[{"id":1,"cnt":1}],"award_title":"","award_btn":"","award_action":"","award_hint":"","award_type:""}}
--或者
--参数说明:  table结构 {"resdata":{"geted_award":{ "prop_award":[{"id":1,"cnt":1}],"status_award":[{"id":1,"cnt":1}],"award_title":"","award_btn":"","award_action":"","award_hint":"","award_type:""}}}
function frame_tools:show_award(table_data)
    local str_data = cjson.encode(table_data);
    if show_award then
        show_award(str_data);
    end
end
--打开实名认证
--参数说明:  int 0/1 是否强制实名
function frame_tools:show_real_name(int_force)
    if show_real_name then
        show_real_name(int_force);
    end

end

--获取大厅版本
function frame_tools:bpversion()
    if bpversion then
        return bpversion();
    end
    return 0;
end

--获取系统配置URL
--参数说明：int  urlid；id详见lobby_define.h
--返回说明：str  url
function frame_tools:get_url_data(int_url_id)
    if get_url_data then
        return get_url_data(int_url_id);
    end
    return "";
end
--获取桌子号
function frame_tools:get_self_table_id()
    if get_self_table_id then
        return get_self_table_id();
    end
    return -1;
end
--获取当前应用的ID
function frame_tools:get_kind_id()
    if get_kind_id then
        return get_kind_id();
    end
    return -1;
end
--获取平台ID
function frame_tools:get_area_id()
    if get_area_id then
        return get_area_id();
    end
    return -1;
end
--获取渠道ID
function frame_tools:get_channel_id()
    if get_channel_id then
        return get_channel_id();
    end
    return -1;
end
--获取包ID
function frame_tools:get_package_id()
    if get_package_id then
        return get_package_id();
    end
    return -1;
end
--获取应用版本
function frame_tools:get_version()
    if get_version then
        return get_version();
    end
    return 0;
end
--是否为审核版本
function frame_tools:is_checking_version()
    if is_checking_version then
        return is_checking_version();
    end
    return true;
end
--是否为最新版本
function frame_tools:is_newest_version()
    if is_newest_version then
        return is_newest_version();
    end
    return false;
end
--是否为访客帐号
function frame_tools:is_visitor_account()
    if is_visitor_account then
        return is_visitor_account();
    end
    return true;
end
--获取应用关键字
function frame_tools:get_keyword()
    if get_keyword then
        return get_keyword();
    end
    return "";
end
--获取更新地址
function frame_tools:get_update_address()
    if get_update_address then
        return get_update_address();
    end
    return "";
end
--获取评价地址
function frame_tools:get_assess_address()
    if get_assess_address then
        return get_assess_address();
    end
    return "";
end
--获取分享地址
function frame_tools:get_share_address()
    if get_share_address then
        return get_share_address();
    end
    return "";
end
--获取网页充值页面地址
function frame_tools:get_webpay_address()
    if get_webpay_address then
        return get_webpay_address();
    end
    return "";
end
--获取人工充值的跳转地址
function frame_tools:get_manualpay_address()
    if get_manualpay_address then
        return get_manualpay_address();
    end
    return "";
end
--获取客服反馈地址
function frame_tools:get_feedback_address()
    if get_feedback_address then
        return get_feedback_address();
    end
    return "";
end
--获取等级信息
--返回说明:  table型 金币数目对应的等级信息 {"level":18,"level_name":"玉皇大帝","next_level_gold":80000000}
function frame_tools:get_level_data(int_gold)
    local str_data = cjson.decode(get_level_data(int_gold));
    return str_data;
end
--获取背景音乐的音量
--返回说明:  number型 音量(0.0 - 1.0)
function frame_tools:get_music_volume()
    if get_music_volume then
        return get_music_volume();
    end
    return 0;
end
--设置背景音乐的音量
--number型 音量(0.0 - 1.0)
function frame_tools:set_music_volume(number_volume)
    if set_music_volume then
        set_music_volume(number_volume);
    end
end
--获取背景音效的音量
--返回说明:  number型 音量(0.0 - 1.0)
function frame_tools:get_effects_volume()
    if get_effects_volume then
        return get_effects_volume();
    end
    return -1;
end
--设置背景音效的音量
--number型 音量(0.0 - 1.0)
function frame_tools:set_effects_volume(number_volume)
    if set_effects_volume then
        set_effects_volume(number_volume);
    end
end

--获取持久化键/值
--参数说明:  string型 键名
--参数说明:  string型 值默认值(无此键名时的返回值)
--返回说明:  string型 值
function frame_tools:get_config_value(str_key, str_value)
    if get_config_value then
        return get_config_value(str_key, str_value);
    end

    return str_value;
end

--设置持久化键/值
--参数说明:  string型 键名
--参数说明:  string型 值
function frame_tools:set_config_value(str_key, str_value)
    if set_config_value then
        set_config_value(str_key, str_value);
        return true
    end

    return false;
end

--调整自己的金币数(用于通知其他界面模块)
--参数说明:  int型 自己的金币数量
function frame_tools:set_self_gold(int_gold)
    if set_self_gold then
        set_self_gold(int_gold);
        return true
    end

    return false;
end

--获取自己的金币数
function frame_tools:get_self_gold()
    if get_self_gold then
        return get_self_gold();
    end
end

--用于调整自己的元宝数(用于通知其他界面模块)
function frame_tools:set_self_ingot(int_ingot)
    if set_self_ingot then
        set_self_ingot(int_ingot);
        return true
    end

    return false;
end

--调整自己的魅力数(用于通知其他界面模块)
function frame_tools:set_self_charm(int_count)
    if set_self_charm then
        set_self_charm(int_count);
        return true
    end

    return false;
end

--获取自己的魅力数
function frame_tools:get_self_charm()
    if get_self_charm then
        get_self_charm();
    end
end

--json结构字符窜，格式：[{"width":float,"height":float,"x":float,"y":float,"bool_touch":bool}]
function frame_tools:set_bugle_custom(str_type)
    local table = self:encode(str_type);
    if set_bugle_custom then
        set_bugle_custom(table);
    end
end
--显示喇叭发送面板
function frame_tools:show_bugle_send()
    if show_bugle_send then
        show_bugle_send();
    end
end

--反正字符串中中文数量
function frame_tools:get_string_count(str_input)
    if get_string_count then
        return get_string_count(str_input)
    end 
    return -1; 
end

--信息系统通知窗
--参数说明:  string型	对话框正文内容
--参数说明:  string型 对话框标题内容
--参数说明:  int型	0:确定框 1:确定/取消类型
--参数说明:  string型 确定按钮文本内容
--参数说明:  string型 取消按钮文本内容
--参数说明:  function型 确定按钮回调函数,格式如下:callback(param1, param2)
--参数说明:  function型 取消按钮回调函数,格式如下:callback(param1, param2)
--参数说明:  int型	回调函数参数1
--参数说明:  string型 回调函数参数2
function frame_tools:show_sysmessage_box(str_content, str_title, int_type, str_btn_ok, str_btn_cancle, callback_ok, callback_cancle, int_param1, str_param2)
    if str_title == nil then
        str_title = "提示"
    end
    if int_type == nil then
        int_type = 0;
    end
    if show_sysmessage_box then
        show_sysmessage_box(str_content, str_title, int_type, str_btn_ok, str_btn_cancle, callback_ok, callback_cancle, int_param1, str_param2);
    end
end
--显示通知窗
--参数说明:  string型	对话框正文内容
--参数说明:  string型 对话框标题内容
--参数说明:  int型	0:确定框 1:确定/取消类型
--参数说明:  string型 确定按钮文本内容
--参数说明:  string型 取消按钮文本内容
--参数说明:  function型 确定按钮回调函数,格式如下:callback(param1, param2)
--参数说明:  function型 取消按钮回调函数,格式如下:callback(param1, param2)
--参数说明:  int型	回调函数参数1
--参数说明:  string型 回调函数参数2
function frame_tools:show_message_box(str_content, str_title, int_type, str_btn_ok, str_btn_cancle, callback_ok, callback_cancle, int_param1, str_param2)
    if str_title == nil then
        str_title = "提示"
    end
    if int_type == nil then
        int_type = 0;
    end
    if show_message_box then
        show_message_box(str_content, str_title, int_type, str_btn_ok, str_btn_cancle, callback_ok, callback_cancle, int_param1, str_param2);
    end
end
--通过GET的方式访问http接口
--参数说明:  string型 请求标识符,即tag
--参数说明:  string型 请求地址
--参数说明:  function型 回调函数，格式如下:callback(tag, code, data)
function frame_tools:http_request_get(str_tag, str_addr, callback)
    if http_request_get then
        http_request_get(str_tag, str_addr, callback);
    end
end
--通过POST的方式访问http接口
--参数说明:  string型 请求标识符,即tag
--参数说明:  string型 请求地址
--参数说明:  string型 POST数据
--参数说明:  function型 回调函数，格式如下:callback(tag, code, data)
function frame_tools:http_request_post(str_tag, str_addr, str_data, callback)
    if http_request_post then
        http_request_post(str_tag, str_addr, str_data, callback);
    end
end
--显示战绩界面
--参数说明: table格式  [{room_code="123456",grade_list={{name="张三",grade=1},{name="李四",grade=2}...}]
function frame_tools:show_game_grade(table_data)
    local str_data = cjson.encode(table_data)
    if show_game_grade then
        show_game_grade(str_data);
        return true;
    end
    return false;
end
--设置活动关闭按钮是否显示
--参数说明: int 1显示/0不显示
function frame_tools:set_activity_btn_show(isShow)
    if set_activity_btn_show then
        set_activity_btn_show(isShow)
        return true;
    end
    return false
end

--获取支付管控
function frame_tools:get_pay_mask()
    if get_pay_mask then
        return get_pay_mask()
    end

    return -1;
end

--获取功能模块管控
function frame_tools:get_module_mask()
    if get_module_mask then
        return get_module_mask()
    end

    return 0;
end

--获取功能模块管控2
function frame_tools:get_module_mask2()
    if get_module_mask2 then
        return get_module_mask2()
    end

    return -1;
end

--获取全局层级
function frame_tools:get_global_zorder()
    if get_global_zorder then
        return get_global_zorder()
    end
    return -1;
end

--request_use_prop  使用道具
--param_int_prop_id 道具id
--param_str         属于游戏id   积分清零卡使用，其他传 ""
--param_call_func    函数回调 1成功  非零 失败理由
function frame_tools:request_use_prop(param_int_prop_id,param_str,param_call_func)
    if param_int_prop_id==nil  then 
        return false;
    end
    if param_str==nil then 
        param_str=""
    end
    local function GetHttpRequest(rescode, resmsg, resdata)
        if rescode == '1' then
            local resdata_json_table = frame_tools.decode(resdata)
            if not resdata_json_table then
                    if param_call_func then
                        param_call_func(-1)
                    end
                return
            end

            if resdata_json_table.rescode ~= nil and resdata_json_table.rescode ~= 1 then
                if show_hinting then 
                    show_hinting(resdata_json_table.resmsg.."("..resdata_json_table.rescode..")")
                end
                if param_call_func then
                    param_call_func(resdata_json_table.rescode)
                end
                return
            end
            if resdata_json_table.resdata then
                G_request_user_data()
                show_hinting("道具已使用成功")
                if param_call_func then
                    param_call_func(1)
                end
            end
        end
    end
    local UsePropUrl = FRAME_URL_CONFIG.UsePropUrl;
    if get_url_data then
        UsePropUrl = get_url_data(31)
    end
    local send_url = make_url(UsePropUrl);
    send_url = string.gsub(send_url, "{PROPID}", param_int_prop_id)
    send_url = string.gsub(send_url, "{PARAM}", param_str)
    send_url = string.gsub(send_url, "&quot;", "\"")
    http_request_get(1, send_url, GetHttpRequest)
    return true;
end

--request_task_award 任务领奖
--param_int_task_id  任务id
--param_call_func  返回  code  data   
--code 0 成功  data正式
--code 非0    失败  失败编码   data ={}
function frame_tools:request_task_award(param_int_task_id, param_call_func, task_model)
    if param_int_task_id == nil then 
        return false;
    end
    --获取url地址
    local AwardTaskUrl = FRAME_URL_CONFIG.AwardTaskUrl 
    if get_url_data then
       AwardTaskUrl = get_url_data(21)
    end
    local send_url = make_url(AwardTaskUrl)
    send_url = string.gsub(send_url, "{TASKID}", param_int_task_id)
    send_url = string.gsub(send_url, "{MODULEID}", task_model);
    send_url = string.gsub(send_url, "&quot;", "\"")
    http_request_get(1, send_url, function(rescode, resmsg, resdata) self:__task_award_callback(rescode, resmsg, resdata, param_call_func) end )
    return true;
end
--award_type = 0
--fundchange = {[1]={fund_id = 1,fund_count = 2000},[2]={}}
--award_title = ""
--status_award = {}
--award_btn = ""
--msg = ""
--nexttask = 0x00000000;
--award_hint = ""
--award_action = ""
--havenext = false
--prop_award = {[1]={fund_id = 1,fund_count = 2000},[2]={}}
function frame_tools:__task_award_callback(rescode, resmsg, resdata, param_call_func)
    if rescode ~= '1' then
        return;
    end
    if param_call_func == nil then
        param_call_func = function(data) end;
    end

    if resdata == nil or resdata == "" then
        param_call_func(-1)
        return
    end

    local resdata_json_table = cjson.decode(resdata)
    if resdata_json_table.rescode ~= nil and resdata_json_table.rescode ~= 1 then 
        self:show_hinting(resdata_json_table.resmsg.."("..resdata_json_table.rescode..")")
        param_call_func(resdata_json_table.rescode)
        return
    end
    if resdata_json_table.resdata then
        param_call_func(resdata_json_table.resdata)
    end
end

--request_game_task     请求任务数据
--param_call_func  返回  code  data   
--code 0 成功  data = {}正式
--code 非0    失败  失败编码
--data._int_id 任务id；
--data._int_type 任务类型：每日，每周，成长；
--data._int_status 任务状态：1未完成,2已完成未领取,4已完成已领取
--data._task_name 任务名字
--data._task_count 任务总进度
--data._complete_count 任务总进度
--data._cur_count 任务当前进度
function frame_tools:request_game_task(game_id, param_call_func)
    --获取url地址
    local DoTaskUrl = FRAME_URL_CONFIG.DoTaskUrl;
    if get_url_data then
        DoTaskUrl = get_url_data(20)
    end
    local send_url = make_url(DoTaskUrl)
    send_url = string.gsub(send_url, "{GAMEID}", game_id)
    send_url = string.gsub(send_url, "&quot;", "\"")
    http_request_get(1, send_url, function(rescode, resmsg, resdata) self:__get_task_callback(rescode, resmsg, resdata, game_id, param_call_func) end)
    return true;
end

--
function frame_tools:__get_task_callback(rescode, resmsg, resdata, game_id, param_call_func)
    if rescode ~= '1' then
        return;
    end
    if param_call_func == nil then
        param_call_func = function(data) end;
    end
    
    if resdata == nil or resdata == "" then
        param_call_func(-1)
        return
    end

    local res = {}
    local tasks = {}

    local resdata_json_table = cjson.decode(resdata)
    if resdata_json_table.rescode ~= nil and resdata_json_table.rescode ~= 1 then
        self:show_hinting(resdata_json_table.resmsg.."("..resdata_json_table.rescode..")")
        param_call_func(resdata_json_table.rescode)
        return
    end
    --每日任务
    if type(resdata_json_table.resdata) =="table" then
        for i=1,#resdata_json_table.resdata,1 do
            table.insert(tasks,resdata_json_table.resdata[i])
        end
    end
    --每周任务
    if type(resdata_json_table.week_tasks) =="table" then
        for i=1,#resdata_json_table.week_tasks,1 do
            table.insert(tasks,resdata_json_table.week_tasks[i])
        end
    end
    --成长任务
    if type(resdata_json_table.forever_tasks) =="table" then
        for i=1,#resdata_json_table.forever_tasks,1 do
            table.insert(tasks,resdata_json_table.forever_tasks[i])
        end
    end
    local function make_data(task)
        local data = {}
        if task.gameid ~= game_id then
            return
        end
        if get_module_mask and task.modulemask1 and task.modulemask1 > 0 and 
            bit._and(get_module_mask(),task.moduletask1) ~= task.moduletask1 then
            return 
        end
        if get_module_mask2 and task.modulemask2 and task.modulemask2 > 0 and 
            bit._and(get_module_mask2(),task.moduletask2) ~= task.moduletask2 then
            return 
        end
        if get_pay_mask and task.paymask and task.paymask > 0 and 
            bit._and(get_pay_mask(),task.paymask) ~= task.paymask then
            return 
        end
        data._int_id = task.task_id
        data._int_type = task.style.label
        data._int_status = task.status
        data._task_name = task.task_name
        data._task_count = task.task_count
        data._complete_count = task.complete_count
        data._cur_count = task.curr_count
        data._task_logo_url = task.task_logo_url
        data._reward_name = frame_tools:string_replace_key(task.reward_name, "\\n", ","); 
        data._reward = task.reward
        data._model = task.task_model
        table.insert(res,data)
    end
    for i=1,#tasks,1 do
        make_data(tasks[i])
    end
       
    param_call_func(res)
end

--获取游戏列表信息
function frame_tools:get_game_list_data()
    if get_game_list_data then 
        return frame_tools:decode(get_game_list_data());
    end
end

--获取游戏列表
function frame_tools:get_game_list()
    if get_game_list then 
        return frame_tools:decode(get_game_list());
    end
end

--获取当前应用所有游戏
function frame_tools:get_all_game_list()
    return frame_logic:get_game_list();
end

--判断当前应用是否存在指定gameid
function frame_tools:find_game_list(game_id)
    return frame_logic:find_game_list(game_id);
end

--窗口跳转
--命令行类型：KEY:VALUE
--发信息：sendsms:{PHONE}|{MESSAGE}
--复制：  copy:{STR}
--进入：  enter:{ID} 例子：enter:108    enter:gameid*1000+siteid
--打开：  open:{ID}  1 金币商城 2 道具商场 3 元宝 4 活动 +可以带参数(游戏内不可用)
--					5 任务	 6 兑换 7 个人中心 8 vip  9 实名认证 10: 我的特权
--					11 背包  13 收货地址 14 奖券夺宝  15分享 17 兑换指定id
--					18 新手提示  19 新手任务  20 月卡战令 21 邀请好友
function frame_tools:on_do_task(str_order)
    if on_do_task then
        on_do_task(str_order);
    end
end

--打开商店
function frame_tools:open_shop(id)
    if on_do_task == nil then
        frame_tools:show_shop();
    end
    
    if id > 0 and id < 3 then
        on_do_task("open:"..id);
    else
        frame_tools:show_shop();
    end
end
--支付
function frame_tools:pay(id)
    if on_do_task == nil then
        frame_tools:show_shop();
    end
    if id > 1000 and id < 4000 then
        on_do_task("pay:"..id);
    end
end
--购买
function frame_tools:buy(id)
    if on_do_task == nil then
        frame_tools:show_shop();
    end
    if id > 1000 and id < 3000 then
        on_do_task("buy:"..id);
    end
end
----------------------------------------------------------------------
--
----------------------------------------------------------------------
--播放音效
function frame_tools:playEffect(path, isLoop) 
    if self.audioengine == nil then
		self.audioengine = SimpleAudioEngine:sharedEngine()
	end

    return self.audioengine:playEffect(path, isLoop)
end
--播放背景音
function frame_tools:playBackground(path)
    if self.audioengine == nil then
		self.audioengine = SimpleAudioEngine:sharedEngine()
	end

    self.audioengine:playBackgroundMusic(path, true)
end
--停止播放背景音乐
function frame_tools:endBackground()
	if self.audioengine == nil then
		self.audioengine = SimpleAudioEngine:sharedEngine()
	end
	self.audioengine:stopBackgroundMusic()
end
--停止所有音效
function frame_tools:stopAllEffects()
    if self.audioengine == nil then
        self.audioengine = SimpleAudioEngine:sharedEngine()
    end
    self.audioengine:stopAllEffects()
end
--停止音效
function frame_tools:stopEffect(id)
	if self.audioengine == nil then
		self.audioengine = SimpleAudioEngine:sharedEngine()
	end
	self.audioengine:stopEffect(id)
end

--加入消息监听
--str_event_name    消息名称
--callback          回调函数
--param1            回调函数额外参数（第二个参数）
--返回监听ID;
--当str_event_name 消息被呼叫时，callback（data,param1）将会被调用
function frame_tools:add_event_listen(str_event_name, callback, param1)
    return self.frame_event_switch:add_event_listen(str_event_name, callback, param1)
end
--删除消息监听,
--str_event_name     消息名称
--id                 监听ID
function frame_tools:delete_event_listen(str_event_name, id)
    self.frame_event_switch:delete_event_listen(str_event_name, id)
end
--唤起消息
--str_event_name        消息名称
--data                  消息信息
function frame_tools:call_event(str_event_name, data)
    self.frame_event_switch:call_event(str_event_name, data)
end
----------------------------------------------------------------------
--
----------------------------------------------------------------------
--获取一个BTN
function frame_tools:get_a_btn()
    local btn = nil;
    if UIButtonExSmall then
        btn = UIButtonExSmall:create()
    else
        btn = Button:create()
    end
    return btn;
end
--
function frame_tools:get_screen_gap()
    return self.frame_layer.m_screenGap;
end
--获取gameid
function frame_tools:get_game_id()
    return frame_logic:get_game_id();
end
--获取椅子数
function frame_tools:get_chair_count()
    return frame_logic:get_chair_count();
end
--table=>string
function frame_tools:encode(data)
    if data == nil then return"";end
    return cjson.encode(data);
end
--string=>table
function frame_tools:decode(data)
    if data == nil then return; end
    return cjson.decode(data);
end
--是否积分场
function frame_tools:is_score_kind()
    return frame_logic:is_score_kind();
end
--获取积分等级（单款自定义）
function frame_tools:get_score_level(score)
    if Frame_Game_Score_Level == nil then return; end;
    local level_1 = Frame_Game_Score_Level[1];
    if level_1 == nil then return; end;
    local level_data = clone(level_1);
    level_data.id = 1;

    for i = 1,#Frame_Game_Score_Level do
        local data = Frame_Game_Score_Level[i];
        if data.score < score then
            level_data = clone(data);
            level_data.id = i;
        end
    end
    return level_data;
end
------------------------------------------------------------------------
--添加信息到测试窗口
function frame_tools:add_test_win_text(str_text)
    if str_text then print(str_text);end
    self.frame_layer:add_test_win_text(str_text);
end
--添加控件到窗口层
function frame_tools:addChild_to_window_layout(window)
    self.frame_layer.window_layout:addChild(window);
end
--添加控件到顶层
function frame_tools:addChild_to_top_layout(node)
    self.frame_layer.top_layout:addChild(node);
end
--设置背景（图片路径）
function frame_tools:set_bg_img(str_path)
    self.frame_layer:set_bg_img(str_path);
end

--打开设置(win_type:1 简单设置，2 带背景切换)
function frame_tools:open_config_win(win_type)
    self.frame_layer:open_config_win(win_type);
end
--打开通用提示
--参数：table 类型 { str_con=""(内容),type = 0（确定框）或1（确定取消）,str_left=""（取消按钮文本）,
--参数：             str_right=""（确定按钮文本）,callback_left=function(取消按钮回调), callback_right=function(确定按钮回调) }
function frame_tools:open_hint_win(table_data)
    self.frame_layer:open_hint_win(table_data);
end
--
--打开个人信息窗口
function frame_tools:open_user_info_win_with_chair(chair_id)
    if chair_id == frame_logic:get_self_chair() then
        self.frame_layer:open_self_user_info();
    else
        self.frame_layer:open_other_user_info(chair_id);
    end
end
--
--打开个人信息窗口
function frame_tools:open_user_info_win_with_userid(user_id)
    if user_id == frame_logic:get_self_user_id() then
        self.frame_layer:open_self_user_info();
    else
        self.frame_layer:open_other_user_info_with_userid(user_id);
    end
end

--打开聊天窗口(win_type:1、左边  2、右边);
function frame_tools:open_chat_win(win_type)
    if win_type == 1 then
        self.frame_layer:open_chat_left_win();
    elseif win_type == 2 then
        self.frame_layer:open_chat_right_win();
    end
end

--关闭聊天窗口
function frame_tools:close_chat_win()
    self.frame_layer:close_chat_win();
end

--打开任务列表（缩放，游戏ID）
function frame_tools:open_task_win(scale, game_id)
    if scale == nil then scale = 1;end;
    if game_id == nil then game_id = self:get_game_id();end
    self.frame_layer:open_task_win(scale,game_id);
end

--获取任务窗口
function frame_tools:get_task_win()
    local task_win = frame_task_win:new();
    task_win:init();
    return task_win;
end

--关闭任务窗口
function frame_tools:close_task_win()
    self.frame_layer:close_task_win();
end

--打开退出提示
function frame_tools:open_exit_win(exit_callback)
    self.frame_layer:open_exit_win(exit_callback);
end

--打开个人举报窗口
function frame_tools:open_single_report_win(userid, name)
    self.frame_layer:open_single_report_win(userid, name)
end

--打开举报窗口
function frame_tools:open_report_win()
    self.frame_layer:open_report_win();
end

function frame_tools:is_short_of_gold()
    if self:is_score_kind() then return false;end

    -- 金币检查
    local user_gold = frame_logic:get_self_gold();
    
    if user_gold == 0 then
        self:open_broke_win();
        return true;
	end

	-- 房间下限金币检查
	local tbl_json = frame_tools:get_room_data()
	if tbl_json == nil then
		return false;
	end

	if bit._and(tbl_json.limit_mask, Frame_Room_Limit.gold_min) == 0 then
        return false;
	end
  
	if user_gold < tbl_json.min_gold then 
		self:open_broke_win();
        return true;
	end	

    return false;
end

--打开金币不足窗口
function frame_tools:open_broke_win()
    self.frame_layer:open_broke_win();
end

--
function frame_tools:close_broke_win_with_gold_up()
    print("close_broke_win_with_gold_up");
  
    self.frame_layer:close_broke_win_with_gold_up();
end

--获取救济金（会自动判断是不是可获取）
function frame_tools:get_relief_gold()
    self.frame_layer:get_relief_gold();
end

--设置聊天和表情位置
--{text_x:number, text_y:number, em_x:number, em_y:number, direction:number}
function frame_tools:init_chat_play(data)
    self.frame_layer:init_chat_play(data)
end

--初始化聊天
--str_list:table { "", "" }
--聊天间隔(wait_time秒内只能发送一次)
function frame_tools:init_game_chat(str_list, wait_time)
    self.frame_layer:init_game_chat(str_list);
    if wait_time and wait_time > 0 then
        self.m_chat_time = wait_time;
    end
end

--初始化礼物位置
function frame_tools:init_gift_pos(pos)
    self.frame_layer:init_gift_pos(pos)
end

--显示聊天(包括表情)
function frame_tools:show_chat(index, id)
    self.frame_layer:show_chat(index, id)
end

--播放礼物动画
function frame_tools:play_gift(from_id, to_id, gift_id, gift_num, scale)
    if scale == nil then scale = 1 end
    self.frame_layer:play_gift(from_id, to_id, gift_id, gift_num, scale);
end

--创建头像
function frame_tools:create_head_item()
    local head = frame_user_head:new()
--    head:init();
    return head;
end


--endregion
