require("src/g_tools/UILabelEx3")
control_tools={}

function control_tools.newBtn(config_data)
	local btn=nil
	if config_data.small==true then
        if UIButtonExSmall then
		    btn=UIButtonExSmall:create()
        else 
            btn=Button:create()
        end
	else
		btn=Button:create()
	end
	config_data.ctype=config_data.ctype or 0
	if config_data.normal then
		if config_data.pressed then
			if config_data.small==true then
				btn:loadTextures(config_data.normal,"",config_data.pressed,config_data.ctype)
			else
				btn:loadTextures(config_data.normal,config_data.normal,config_data.pressed,config_data.ctype)
			end
		else
			btn:loadTextures(config_data.normal,"","",config_data.ctype)
		end
	end
	if config_data.size then
		btn:setScale9Enabled(true)
		btn:setSize(config_data.size)
	end
	if config_data.opacity then
		btn:setOpacity(config_data.opacity)
	end
	if config_data.scale then
		btn:setScale(config_data.scale)
	end
	if config_data.anchor then
		btn:setAnchorPoint(config_data.anchor)
	end
	return btn
end

function control_tools.newImg(config_data)
	local img=ImageView:create()
	config_data.ctype=config_data.ctype or 0
	if config_data.path then
		img:loadTexture(config_data.path,config_data.ctype)
	end
	if config_data.size then
		img:setScale9Enabled(true)
		img:setSize(config_data.size)
	end
	if config_data.opacity then
		img:setOpacity(config_data.opacity)
	end
	if config_data.scale then
		img:setScale(config_data.scale)
	end
	if config_data.anchor then
		img:setAnchorPoint(config_data.anchor)
	end
	return img
end

function control_tools.newEdit(config_data)
	local edit=UIEditBox:create(config_data.hint,config_data.size,"Arial",config_data.font)
	if config_data.color then
		edit:setColor(config_data.color)
	end
	if config_data.scolor then
		edit:setColorSpaceHolder(config_data.scolor)
	end
	if config_data.str then
		edit:setText(config_data.str)
	end
	if config_data.opacity then
		label:setOpacity(config_data.opacity)
	end
	if config_data.anchor then
		edit:setAnchorPoint(config_data.anchor)
	end
	return edit
end

function control_tools.newLabel(config_data)
	local label=Label:create() 
	if config_data.font then
		label:setFontSize(config_data.font)
	end
	if config_data.color then
		label:setColor(config_data.color)
	end
	if config_data.size then
		label:setSize(config_data.size)
	end
	if config_data.str then
		label:setText(config_data.str)
	end
	if config_data.opacity then
		label:setOpacity(config_data.opacity)
	end
	if config_data.anchor then
		label:setAnchorPoint(config_data.anchor)
	end
	return label
end

function control_tools.newLabelBM(config_data)
	local label=LabelBMFont:create()
	label:setFntFile(config_data.path)
	if config_data.opacity then
		label:setOpacity(config_data.opacity)
	end
	if config_data.scale then
		label:setScale(config_data.scale)
	end
	if config_data.anchor then
		label:setAnchorPoint(config_data.anchor)
	end
	return label
end

function control_tools.newLabelEx(config_data)
	local label=UILabelEx:create()
	if config_data.font then
		label:setFontSize(config_data.font)
	end
	if config_data.color then
		label:setColor(config_data.color)
	end
	if config_data.opacity then
		label:setOpacity(config_data.opacity)
	end
	if config_data.anchor then
		label:setAnchorPoint(config_data.anchor)
	end
	return label
end

function control_tools.newLabelEx3(config_data)
	local label=UILabelEx3.new()
	if config_data.font then
		label:setFontSize(config_data.font)
	end
	if config_data.color then
		label:setColor(config_data.color)
	end
	if config_data.opacity then
		label:setOpacity(config_data.opacity)
	end
	if config_data.anchor then
		label:setAnchorPoint(config_data.anchor)
	end
	return label
end

function control_tools.newScroll(config_data)
	local scroll=ScrollView:create()
	if config_data.direction then
		scroll:setDirection(config_data.direction)
	else
		scroll:setDirection(_G.SCROLLVIEW_DIR_VERTICAL)
	end
	if config_data.size then
		scroll:setSize(config_data.size)
	end
	if config_data.csize then
		scroll:setInnerContainerSize(config_data.csize)
	end
	return scroll
end

--获取所有子节点
--param	sender  父节点
function control_tools.getAllChild(sender)
	local child_list={}
	local children= sender:getChildren()
	local child_cnt=children:count()
	for i=0,child_cnt-1,1 do
		table.insert(child_list,children:objectAtIndex(i))
	end
	return child_list
end
