--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

frame_event_switch = class("frame_event_switch");

function frame_event_switch:ctor()
    self.m_index = 0
end

function frame_event_switch:init()
    self.event_name_list = {};
    self.event_listen_list = {};
end

--回调函数内禁止调用call_event，防止死循环
function frame_event_switch:add_event_listen(str_event_name, callback, param)
    local event_index = -1;
    for k,v in pairs(self.event_name_list) do
        if v == str_event_name then
            event_index = k;
        end
    end

    if event_index == -1 then
        table.insert(self.event_name_list, str_event_name);
        table.insert(self.event_listen_list, {})
        event_index = #self.event_name_list;
    end

    local callback_data = {};
    callback_data.callback = callback;
    callback_data.param1 = param1;
    callback_data.id = self.m_index;

    self.m_index = self.m_index + 1;

    table.insert(self.event_listen_list[event_index], callback_data)

    return callback_data.id;
end

function frame_event_switch:delete_event_listen(str_event_name, callback_id)
    local event_index = -1;
    for k,v in pairs(self.event_name_list) do
        if v == str_event_name then
            event_index = k;
            break;
        end
    end

    if event_index == -1 then return; end

    local event_listen_list = self.event_listen_list[event_index];
    
    for k,v in pairs(event_listen_list) do
        if v.id == callback_id then
            table.remove(event_listen_list,k);
            break;
        end
    end 

end

function frame_event_switch:call_event(str_event_name, data)
    local event_index = -1;
    for k,v in pairs(self.event_name_list) do
        if v == str_event_name then
            event_index = k;
            break;
        end
    end

    if event_index == -1 then return; end

    local event_listen_list = self.event_listen_list[event_index];
    
    local delete_list = {};
    for k,v in pairs(event_listen_list) do
        if v.callback then
            v.callback(data, v.param);
        else
            table.insert(delete_list, v.id);
        end
    end 

    for k,v in pairs(delete_list) do
        self:delete_event_listen(str_event_name, v);
    end
end

--endregion
