--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

frame_chat_player = class("frame_chat_player", function() return ImageView:create() end);

function frame_chat_player:ctor()
    self._chat_list = {};
    self._emotion_list = {};
    self._emotion_pos = {};

    self._emotion_scale = 1;

    self._str_chat = {};
end

function frame_chat_player:init()
    
end 

function frame_chat_player:set_chat_list(str_list)
    self._str_chat = str_list;
end

function frame_chat_player:init_chat_play(data)
    if data == nil then return;end

    self._emotion_pos = {};

    local count = #data;
    for k,v in pairs(data) do
        --文字
        local chat_item = nil;
        if k > #self._chat_list then
            chat_item = frame_chat_item:new();
            self:addChild(chat_item);
            chat_item:init()

            table.insert(self._chat_list, chat_item);
        else 
            chat_item = self._chat_list[k];
        end

        chat_item:set_type(v.direction);
        chat_item:setPosition(ccp(v.text_x, v.text_y));

        --表情
        local emotion_item = nil;
        if k > #self._emotion_list then
            emotion_item = frame_emotion_item:new();
            self:addChild(emotion_item);
            emotion_item:init()

            table.insert(self._emotion_list, emotion_item);
        else 
            emotion_item = self._emotion_list[k];
        end
        emotion_item:set_type(v.direction);
        if v.direction == FRAME_CHAT_DIRECTION.left_top then
            emotion_item:setPosition(ccp(v.em_x, v.em_y - 17));
        elseif v.direction == FRAME_CHAT_DIRECTION.left_down then
            emotion_item:setPosition(ccp(v.em_x, v.em_y + 17));
        elseif v.direction == FRAME_CHAT_DIRECTION.right_top then
            emotion_item:setPosition(ccp(v.em_x, v.em_y - 17));
        elseif v.direction == FRAME_CHAT_DIRECTION.right_down then
            emotion_item:setPosition(ccp(v.em_x, v.em_y + 17));
        end
--        emotion_item:setPosition(ccp(v.em_x, v.em_y));

        table.insert(self._emotion_pos, ccp(v.em_x, v.em_y) );

        self._emotion_scale = v.emotion_scale;
    end
 
end

function frame_chat_player:show_chat_text(view_id, chat_id)
    if view_id > #self._chat_list then return; end
    if chat_id > #self._str_chat then return; end

    self._chat_list[view_id]:show_text(self._str_chat[chat_id]);
end

function frame_chat_player:show_emotion_ani(view_id, emotion_id)
    if view_id > #self._emotion_list then return; end
    if emotion_id < 0 or emotion_id > 31 then return; end

    self._emotion_list[view_id]:show_emotion(emotion_id);

--    self._emotion_list[view_id]:stopAllActions();
--    self._emotion_list[view_id]:setVisible(false);
--
--    local show_time = 3;
--    local str_ani = "";
--    if emotion_id < 10 then
--        str_ani = "biaoqingdhxz0"..emotion_id;
--    else
--        str_ani = "biaoqingdhxz"..emotion_id;
--    end
--
--    local emotion_item = CCArmature:create(str_ani);
--    self:addNode(emotion_item);
--    emotion_item:setScale(self._emotion_scale);
--    emotion_item:setPosition( self._emotion_pos[view_id] );
--    emotion_item:getAnimation():playWithIndex(0);
--    self._emotion_list[view_id] = emotion_item;
--
--    local array = CCArray:create();
--    array:addObject(CCDelayTime:create(show_time) );
--    array:addObject(CCCallFunc:create(function() self._emotion_list[view_id]:setVisible(false); end) );
--    self._emotion_list[view_id]:runAction(CCSequence:create(array) );
end

-----------------------------------------------------------------------------------------------
--
frame_chat_item = class("frame_chat_item", function() return ImageView:create() end);

function frame_chat_item:ctor()
    self.m_color = ccc3(125, 79, 46);

    self.m_self_width = 206;
    self.m_self_height = 86;

    self.m_scroll_width = 180;

    self.m_gap = self.m_self_width - self.m_scroll_width;
end

function frame_chat_item:init()
    self:setVisible(false);

    self._bg = ImageView:create();
    self:addChild(self._bg);
    self._bg:loadTexture("tips_left_bottom.png", 1);
    self._bg:setCapInsets(CCRectMake( 50, 35, 135, 30 ))
    self._bg:setScale9Enabled(true);
    self._bg:setSize(CCSizeMake(self.m_self_width, self.m_self_height) );

    self._text_scroll = ScrollView:create();
    self:addChild(self._text_scroll);
    self._text_scroll:setAnchorPoint(ccp(0.5, 0.5) );
    self._text_scroll:setPosition(ccp(0, 18 ) );
    self._text_scroll:setDirection(_G.SCROLLVIEW_DIR_VERTICAL)
    self._text_scroll:setSize(CCSizeMake(self.m_scroll_width, 40));
    self._text_scroll:setTouchEnabled(false);

    self._text = Label:create();
    self._text_scroll:addChild(self._text);
    self._text:setAnchorPoint(ccp(0, 0));
    self._text:setPosition(ccp(0, 0));
    self._text:setFontSize(22);
    self._text:setColor(self.m_color);
end

function frame_chat_item:set_type(type)
    if type == FRAME_CHAT_DIRECTION.left_top then
        self._bg:loadTexture("tips_left_top.png", 1);
        self._bg:setAnchorPoint(ccp(0,0.5));
        self._text_scroll:setAnchorPoint(ccp(0,0.5));
        self._text_scroll:setPosition(ccp(13, -2 ) );
    elseif type == FRAME_CHAT_DIRECTION.left_down then
        self._bg:loadTexture("tips_left_bottom.png", 1);
        self._bg:setAnchorPoint(ccp(0,0.5));
        self._text_scroll:setAnchorPoint(ccp(0,0.5));
        self._text_scroll:setPosition(ccp(13, 15 ) );
    elseif type == FRAME_CHAT_DIRECTION.right_top then
        self._bg:loadTexture("tips_right_top.png", 1);
        self._bg:setAnchorPoint(ccp(1,0.5));
        self._text_scroll:setAnchorPoint(ccp(1,0.5));
        self._text_scroll:setPosition(ccp(-13, -2 ) );
    elseif type == FRAME_CHAT_DIRECTION.right_down then
        self._bg:loadTexture("tips_right_bottom.png", 1);
        self._bg:setAnchorPoint(ccp(1,0.5));
        self._text_scroll:setAnchorPoint(ccp(1,0.5));
        self._text_scroll:setPosition(ccp(-13, 15 ) );
    end
end

function frame_chat_item:show_text(str_text)
--    self._img_bar:setOpacity(0);
--    self._text:setOpacity(0);
    
    self._text:stopAllActions();
    self:stopAllActions();

    self:setVisible(true);

    self._text:setText(str_text);
    self._text:setPosition(ccp(0, 0));
    local width = self._text:getSize().width;
    local time = width / 70;
    local array = CCArray:create();
    array:addObject(CCDelayTime:create(1) );
    if width > self.m_scroll_width then
        array:addObject(CCMoveTo:create(time, ccp(self.m_scroll_width - width, 0) ) );
        self._text_scroll:setSize(CCSizeMake(self.m_scroll_width, 40));
        self._bg:setSize(CCSizeMake(self.m_self_width, self.m_self_height) );
    else
        array:addObject(CCDelayTime:create(time));
        self._text_scroll:setSize(CCSizeMake(width, 40));
        self._bg:setSize(CCSizeMake(width + self.m_gap, self.m_self_height) );
    end
--    array:addObject(CCFadeOut:create(0.5) );
    self._text:runAction(CCSequence:create(array) );

    local array1 = CCArray:create();
--    array1:addObject(CCFadeIn:create(0.5) );
    array1:addObject(CCDelayTime:create(time + 2));
--    array1:addObject(CCFadeOut:create(0.5) );
    array1:addObject(CCCallFunc:create(function() self:setVisible(false) end) );
    self:runAction(CCSequence:create(array1) ); 
end


------------------------------------------------------------------------------------
--
frame_emotion_item = class("frame_emotion_item", function() return ImageView:create() end);

function frame_emotion_item:ctor()
    self.m_self_width = 150;
    self.m_self_height = 120;
end

function frame_emotion_item:init()
    self:setVisible(false);

    self._bg = ImageView:create();
    self:addChild(self._bg);
    self._bg:loadTexture("tips_left_bottom.png", 1);
    self._bg:setCapInsets(CCRectMake( 50, 25, 88, 20 ))
    self._bg:setScale9Enabled(true);
    self._bg:setSize(CCSizeMake(self.m_self_width, self.m_self_height) );

    self._emotion = CCArmature:create();
    self:addNode(self._emotion);
end

function frame_emotion_item:set_type(type)
    if type == FRAME_CHAT_DIRECTION.left_top then
        self._bg:loadTexture("tips_left_top.png", 1);
        self._bg:setAnchorPoint(ccp(0,0.5));
    elseif type == FRAME_CHAT_DIRECTION.left_down then
        self._bg:loadTexture("tips_left_bottom.png", 1);
        self._bg:setAnchorPoint(ccp(0,0.5));
    elseif type == FRAME_CHAT_DIRECTION.right_top then
        self._bg:loadTexture("tips_right_top.png", 1);
        self._bg:setAnchorPoint(ccp(1,0.5));
    elseif type == FRAME_CHAT_DIRECTION.right_down then
        self._bg:loadTexture("tips_right_bottom.png", 1);
        self._bg:setAnchorPoint(ccp(1,0.5));
    end
    self.m_type = type;
end

function frame_emotion_item:show_emotion(emotion_id)
    self._emotion:stopAllActions();
    self._emotion:setVisible(false);
    self:stopAllActions();

    self:setVisible(true);

    local show_time = 3;
    local str_ani = "";
    if emotion_id < 10 then
        str_ani = "biaoqingdhxz0"..emotion_id;
    else
        str_ani = "biaoqingdhxz"..emotion_id;
    end

    self._emotion = CCArmature:create(str_ani);
    self:addNode(self._emotion);
    self._emotion:setScale(0.45);
    
    if self.m_type == FRAME_CHAT_DIRECTION.left_top then
        self._emotion:setPosition(ccp(75,-40));
    elseif self.m_type == FRAME_CHAT_DIRECTION.left_down then
        self._emotion:setPosition(ccp(75,-25));
    elseif self.m_type == FRAME_CHAT_DIRECTION.right_top then
        self._emotion:setPosition(ccp(-75,-40));
    elseif self.m_type == FRAME_CHAT_DIRECTION.right_down then
        self._emotion:setPosition(ccp(-75,-25));
    end

    self._emotion:getAnimation():playWithIndex(0);

    local array = CCArray:create();
    array:addObject(CCDelayTime:create(show_time) );
    array:addObject(CCCallFunc:create(function() self._emotion:setVisible(false); end) );
    self._emotion:runAction(CCSequence:create(array) );

    local array1 = CCArray:create();
--    array1:addObject(CCFadeIn:create(0.5) );
    array1:addObject(CCDelayTime:create(show_time));
--    array1:addObject(CCFadeOut:create(0.5) );
    array1:addObject(CCCallFunc:create(function() self:setVisible(false) end) );
    self:runAction(CCSequence:create(array1) ); 
end

--endregion
