--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

frame_finish_base = class("frame_finish_base", function() return frame_window:new() end)

function frame_finish_base:ctor()
   self:init(); 
end

function frame_finish_base:init()
    local visibleSize = frame_tools:get_visibleSize();
    local screenGap = frame_tools:get_screen_gap();

    self:setVisible(false);

    --举报按钮
    self._btn_report = frame_tools:get_a_btn();
    self:addChild(self._btn_report);
    self._btn_report:loadTextureNormal("frame/image/frame_report_btn.png");
    self._btn_report:setPosition(ccp(visibleSize.width / 2 - 50 - frame_tools:get_screen_gap(), visibleSize.height / 2 - 50));
    self._btn_report:addTouchEventListener(function(sender, touchType) self:on_btn_report(sender, touchType) end);    


    --测试用
    self._btn_close = frame_tools:get_a_btn();
    self:addChild(self._btn_close);
    self._btn_close:loadTextureNormal("frame/image/frame_report_btn.png");
    self._btn_close:setPosition(ccp(50 - visibleSize.width / 2, visibleSize.height / 2 - 50));
    self._btn_close:addTouchEventListener(function(sender, touchType) self:show_window(false) end);    
    self._btn_close:setVisible(false);

    --任务
    self._task_win = frame_task_win:new();
    self._task_win:init();
    self:addChild(self._task_win);
    self._task_win:setPosition(ccp(screenGap + 170 - visibleSize.width/2, 0))
    self._task_win:setAnchorPoint(ccp(0.5,0))
    self._task_win:setZOrder(10000);

    --举报
    self.report_win = frame_report_win:new();
    self:addChild(self.report_win);
    self.report_win:init();
    self.report_win:setZOrder(20000);
    --二人游戏不显示举报按钮
    if frame_tools:get_chair_count() <=  2 then
        self._btn_report:setVisible(false);
    end
end
--打开举报页面
function frame_finish_base:on_btn_report(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end

    frame_tools:playEffect("frame/sound/click.mp3");

    local user_data = {}; 
    local all_user_data = frame_logic:get_all_user_data();
    for i=1,#all_user_data do
        if i - 1 ~= frame_logic:get_self_chair() and next(all_user_data[i]) ~= nil then
            table.insert(user_data, all_user_data[i]);
        end
    end
    self.report_win:set_user_item(user_data);
    self.report_win:__show_layer();
--    self.report_win:show_window(true);
end
--显示任务界面
function frame_finish_base:show_task_win(game_id)
    if game_id == nil then game_id = frame_tools:get_game_id() end;
    self._task_win:show_task(game_id, function(total,award,award_list) self:show_task_callback(total,award,award_list); end, false);
end
--关闭任务界面
function frame_finish_base:close_task_win()
    self._task_win:show_window(false, false);
end
--设置任务窗口大小
function frame_finish_base:set_task_size(width,height)
    self._task_win:set_win_size(width,height);
end
--获取任务窗口控件，可用来缩放
function frame_finish_base:get_task_win()
    return self._task_win;
end
--用于判断是否显示金币不足
function frame_finish_base:show_task_callback(total_count, award_count, award_list)
    local user_gold = frame_logic:get_self_user_data().gold;

--    frame_tools:add_test_win_text("frame_finish_base:show_task_callback:gold"..user_gold.." award_count:"..award_count);

    if award_count > 0 then
        local add_gold = 0;
        for k,v in pairs(award_list) do
            if v.id == FRAME_USER_PROP_ID.gold then
                add_gold = add_gold + v.cnt;
            end
        end
        user_gold = user_gold + add_gold;
    end

    local tbl_json = frame_tools:get_room_data()
    if user_gold <= 0 then
        frame_tools:open_broke_win();
        return;
    end
    if bit._and(tbl_json.limit_mask, Frame_Room_Limit.gold_min) ~= 0 then
        if user_gold < tbl_json.min_gold then
            frame_tools:open_broke_win();
            return;
        end
    end
end

--endregion
