--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

frame_task_win = class("frame_task_win",function() return frame_window:new() end);

function frame_task_win:ctor()
    self.m_gameid = 0;
    self._task_list = {};
    self.m_item_callback = nil;

    self.m_item_count = 0;

    self.m_get_award_count = 0;
    self.m_award_data = {};

    self.m_callback = nil;
end

function frame_task_win:init(item_callback)
    self:setVisible(false);

--    self.__back:loadTexture("");
    self.__back:setVisible(false);

    self.m_item_callback = item_callback;

    self._bg = ScrollView:create();
    self:addChild(self._bg);
    self._bg:setAnchorPoint(ccp(0.5,0.5));
    self._bg:setSize(CCSizeMake(330,300));
    self._bg:setDirection( _G.SCROLLVIEW_DIR_VERTICAL);

    self._btn_open_close = frame_tools:get_a_btn();
    self._btn_open_close:loadTextureNormal("frame/image/frame_task_win/frame_task_open_btn.png");
    self:addChild(self._btn_open_close);
    self._btn_open_close:setPosition(ccp(-330/2 + 35, 0));
    self._btn_open_close:addTouchEventListener(function(sender, touchType) self:on_btn_open(sender, touchType) end);


--    self.__back = ImageView:create()
--    self._bg:addChild(self.__back);
--    self.__back:loadTexture("frame/image/bg_black.png");
--    self.__back:setScale9Enabled(true);
--    self.__back:setSize(frame_tools:get_visibleSize());
--    self.__back:setPosition(ccp(500,300));
end

function frame_task_win:set_win_size(width,height)
    if width == nil or width < 330 then width = 330;end
    if height == nil then height = 300;end

    self._bg:setSize(CCSizeMake(width,height));
end

function frame_task_win:show_task(game_id, callback, is_change_zorder)
    if game_id == nil then return; end
    if is_change_zorder == nil then
        is_change_zorder = true;
    end
    self.m_is_change_zorder = is_change_zorder;
    self.m_callback = callback;

    self.m_gameid = game_id
    frame_tools:request_game_task(self.m_gameid, function(data) self:load_task(data) end);
end

function frame_task_win:load_task(data)
    if type(data) ~= "table" or next(data) == nil then 
        if self.m_callback then
            self.m_callback(0, 0, {});
        end
        return;
    end

    self.m_get_award_count = 0;
    self.m_award_data = {};

    self._btn_open_close:setVisible(false);
    self._bg:setVisible(true);

    local size = self._bg:getSize();
    local width = size.width;
    local item_width = 330;

    for k,v in pairs(self._task_list) do
        v:setVisible(false);
    end

    local index = 0;
    local get_award_count = 0;
    local award_list = {};
    for k,v in pairs(data) do

        if v._int_status ~= 4 then
            index = index + 1;
            local list_inidex = index;
            local item = nil;
            if index > #self._task_list then
                item = frame_task_item:new();
                item:init(function(taskid, model) self:on_get_award(taskid, model, list_inidex) end, function() self:on_btn_task() end );
                self._bg:addChild(item);
                table.insert(self._task_list, item);
            else    
                item = self._task_list[index];
            end
            item:stopAllActions();
            item:setPosition(ccp( -item_width/2,112 * (index - 0.5) ) );
            item:set_data(v);
            item:setVisible(true);
            if v._int_status == 2 then
                get_award_count = get_award_count + 1;
                for k1,v1 in pairs(v._reward) do 
                    table.insert(award_list, v1);
                end
            end
            
            local array = CCArray:create()
            array:addObject(CCDelayTime:create(0.1 * index ) );
            array:addObject(CCMoveTo:create(0.2, ccp( item_width/2,112 * (index - 0.5) ) ) );
            --领取奖励
            if k == #data then
                array:addObject(CCDelayTime:create(0.1 ) );
                array:addObject(CCCallFunc:create(function() self:get_task_award(index); end  ));
            end

            item:runAction(CCSequence:create(array));
        end
        
    end
    
    local height = 112 * index
    if height < size.height then height = size.height end;

    print("height:",height," data:",#data);

    self._bg:setInnerContainerSize(CCSizeMake(size.width, height));
    self._bg:jumpToBottom()

    self.m_item_count = index;
    if index > 0 then
        if self.m_is_change_zorder then
            self:show_window(true, false);
        else
            self:setVisible(true);
        end
    end

    if self.m_callback then
        self.m_callback(index, get_award_count, award_list);
    end
end

function frame_task_win:get_task_award(item_count)
    for i=1,item_count do
        self._task_list[i]:on_get_award();
--        self._task_list[i]:show_award_ani({ [1]={cnt = 2000,id=1 },[2]={cnt = 2,id=1002 } });    --test
    end
end

function frame_task_win:on_get_award(taskid, model, index)
    frame_tools:request_task_award(taskid, function(data) self:award_callback(data, index) end, model);

    self.m_get_award_count = self.m_get_award_count + 1;
end

function frame_task_win:on_btn_task()
    local item_width = 330;
    for i=1, self.m_item_count do
        local array = CCArray:create()
        array:addObject(CCMoveTo:create(0.2, ccp( -item_width/2,112 * (i - 0.5) ) ) );

        if i == self.m_item_count then
            array:addObject(CCCallFunc:create(function() self._bg:setVisible(false);self._btn_open_close:setVisible(true); end))
        end

        self._task_list[i]:runAction(CCSequence:create(array));
    end
end

function frame_task_win:on_btn_open(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    self._btn_open_close:setVisible(false);
    self._bg:setVisible(true);

    local item_width = 330;
    for i=1, self.m_item_count do
        local array = CCArray:create()
        array:addObject(CCMoveTo:create(0.2, ccp( item_width/2, 112 * (i - 0.5) ) ) );

        self._task_list[i]:stopAllActions();
        self._task_list[i]:runAction(CCSequence:create(array));
    end
end

function frame_task_win:award_callback(data, index)
    self.m_get_award_count = self.m_get_award_count - 1;
    if type(data) ~= "table" then return;end
    if next(data) == nil then return end;
    if data.prop_award == nil then return end;

    if self.m_item_callback then
        self.m_item_callback(data.prop_award);
    end

    self._task_list[index]:show_award_ani(data.prop_award);

    for k,v in pairs(data.prop_award) do
        table.insert(self.m_award_data, v);
    end

    if self.m_get_award_count > 0 then return;end

    local str_award = "完成任务,获得";
    local award_count = {};
    for k,v in pairs(self.m_award_data) do
        if award_count[v.id] then
            award_count[v.id] =  award_count[v.id] + v.cnt;
        else
            award_count[v.id] =  v.cnt;
        end
    end

    for k,v in pairs(award_count) do
        if FRAME_USER_PROP_NAME[k] ~= nil then
            str_award = str_award..v..FRAME_USER_PROP_NAME[k];
        end
    end
    frame_tools:show_hinting(str_award);
end
----------------------------------------------------------------------------------------------------------------------
--
frame_task_item = class("frame_task_item", function() return frame_tools:get_a_btn() end );

function frame_task_item:ctor()
    self.m_color_task_complete = ccc3(209,95,30);
    self.m_color_award_complete = ccc3(120,78,17);
    self.m_color_task_unfinished = ccc3(121,57,21);
    self.m_color_award_unfinished = ccc3(244,107,24);

    self.m_task_id = 0
    self.m_str_task = ""
    self.m_curr_count = 0;
    self.m_task_count = 0;
    self.m_int_status = 0;
    self.m_complate_count = 0;
    self.m_logo = "";
    self.m_str_reward = "";
    self.m_reward = {};
    self.m_model = 1;

    self.m_scroll_width = 200;

    self.m_callback = nil
--    self:setTouchEnabled(false);
end

function frame_task_item:init(callback,callback2)
    self.m_callback = callback;
    self.m_callback2 = callback2;

    self:loadTextures("frame_task_item_bg1.png","frame_task_item_bg1.png","frame_task_item_bg1.png", 1);
    self:addTouchEventListener(function(sender, touchType) self:on_btn_task(sender, touchType)  end)

    self._scroll_task = ScrollView:create();
    self:addChild(self._scroll_task);
    self._scroll_task:setAnchorPoint(ccp(0,0.5));
    self._scroll_task:setSize(CCSizeMake(self.m_scroll_width,50));
    self._scroll_task:setDirection( _G.SCROLLVIEW_DIR_VERTICAL); 
    self._scroll_task:setPosition(ccp(-50,30));
    self._scroll_task:setTouchEnabled(false);

    self.m_label_task_y = 10;
    self._label_task = Label:create();
    self._label_task:setFontSize(24);
    self._label_task:setColor(self.m_color_task_unfinished);
    self._scroll_task:addChild(self._label_task);
    self._label_task:setAnchorPoint(ccp(0, 0) );
    self._label_task:setPosition(ccp(0, self.m_label_task_y) );
    self._label_task:setText("赢得50000金币");

    self._progress_task_bg = ImageView:create();
    self:addChild(self._progress_task_bg);
    self._progress_task_bg:setPosition(ccp(35,2));
    self._progress_task_bg:loadTexture("frame_task_progress_bg.png", 1);

    self._progress_task = CCProgressTimer:create(CCSprite:createWithSpriteFrameName("frame_task_progress_fg.png") );
    self._progress_task_bg:addNode(self._progress_task);
    self._progress_task:setPosition(ccp(0,0))
    self._progress_task:setMidpoint(ccp(0,0.5))
    self._progress_task:setBarChangeRate(ccp(1,0));
    self._progress_task:setType(kCCProgressTimerTypeBar);
    self._progress_task:setPercentage(2/5*100);

    self._progress_task_label = Label:create();
    self._progress_task_bg:addChild(self._progress_task_label);
    self._progress_task_label:setPosition(ccp(0,0));
    self._progress_task_label:setText("2/5");
    self._progress_task_label:setFontSize(20);

    self._label_award = Label:create();
    self._label_award:setFontSize(22);
    self._label_award:setColor(self.m_color_award_unfinished);
    self:addChild(self._label_award);
    self._label_award:setAnchorPoint(ccp(0, 0.5) );
    self._label_award:setPosition(ccp(-50, -25) );
    self._label_award:setText("5000金币，5奖券");
    
    self._award_logo = ImageView:create();
    self:addChild(self._award_logo);
    self._award_logo:setPosition(ccp(-115, 0) );
    self._award_logo:loadTexture("../5000/task_icon_1.png");

    self._finish_logo = ImageView:create()
    self:addChild(self._finish_logo);
    self._finish_logo:loadTexture("frame_task_finish.png",1);
    self._finish_logo:setPosition(ccp(125, 21));
    self._finish_logo:setVisible(false);

    self._award_label = {};
    self._award_label_pos = {ccp(160, 20), ccp(160, -20) }
    for i=1,2  do
        local award_label = Label:create()
        self:addChild(award_label);
        award_label:setFontSize(22);
        award_label:setColor(self.m_color_award_unfinished);
        award_label:setText("金币+19000");
        award_label:setAnchorPoint(ccp(0,0.5));
        award_label:setPosition(self._award_label_pos[i]);
        award_label:setZOrder(-5);  

        table.insert(self._award_label, award_label);
    end
end

function frame_task_item:set_data(data)
    self.m_task_id = data._int_id or 0
    self.m_model = data._model or 1;
    self.m_int_status = data._int_status or 0;
    self.m_str_task = data._task_name or ""
    self.m_curr_count = data._cur_count or 0;
    self.m_task_count = data._task_count or 0;
    self.m_complate_count = data._complete_count or 0;
    self.m_logo = data._task_logo_url or "";
    self.m_str_reward = data._reward_name or "";
    self.m_reward = data._reward or {};

    self:update_data();
end

function frame_task_item:update_data()
    self:show_text(self.m_str_task);

    self._progress_task_label:setText(tostring(self.m_curr_count).."/"..tostring(self.m_complate_count) );
    self._progress_task:setPercentage(self.m_curr_count/self.m_complate_count*100);
    self._label_award:setText(self.m_str_reward);

    self._award_logo:loadTexture("../5000/"..self.m_logo);

    for k,v in pairs(self._award_label) do
        v:setVisible(false);
    end

    if self.m_int_status == 2 then
        self:loadTextures("frame_task_item_bg2.png","frame_task_item_bg2.png","frame_task_item_bg2.png", 1);
        self._finish_logo:setVisible(false);
    elseif self.m_int_status == 4 then
        self:loadTextures("frame_task_item_bg2.png","frame_task_item_bg2.png","frame_task_item_bg2.png", 1);
        self._finish_logo:setVisible(true);
    else
        self:loadTextures("frame_task_item_bg1.png","frame_task_item_bg1.png","frame_task_item_bg1.png", 1);
        self._finish_logo:setVisible(false);
    end
end

function frame_task_item:on_btn_task(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");
    if self.m_callback2 then
         self.m_callback2(sender, touchType);
    end
end

function frame_task_item:on_get_award()
    if self.m_int_status ~= 2 then return; end

    if self.m_callback then
        self.m_callback(self.m_task_id, self.m_model);
    end

--    self._finish_logo:setVisible(true);
end

function frame_task_item:show_award_ani(data)
    self._finish_logo:setScale(20);
    self._finish_logo:setOpacity(0);
    self._finish_logo:setVisible(true);
    
    self._finish_logo:runAction(CCEaseSineIn:create(CCScaleTo:create(0.3, 1) ) );  
    self._finish_logo:runAction(CCEaseSineIn:create(CCFadeIn:create(0.3) ) ); 
    
--    for k,v in pairs(data) do
--        if k > #self._award_label then break; end
--        if FRAME_USER_PROP_NAME[v.id] ~= nil then
--            self._award_label[k]:setText(FRAME_USER_PROP_NAME[v.id].."+"..v.cnt);
--            local width = self._award_label[k]:getSize().width;
--            local x = self._award_label_pos[k].x - width;
--            local y = self._award_label_pos[k].y;
--            self._award_label[k]:setPosition(ccp(x, y));
--            self._award_label[k]:setVisible(true);
--            self._award_label[k]:runAction(CCMoveTo:create(0.5, self._award_label_pos[k]));
--        end
--    end   



end

function frame_task_item:show_text(text)
    self._label_task:stopAllActions();

    self._label_task:setText(self.m_str_task);
    self._label_task:setPosition(ccp(0,self.m_label_task_y) );
    local width = self._label_task:getSize().width;
    if width <= self.m_scroll_width then return;end;

    local gap = width - self.m_scroll_width;

    local array = CCArray:create();
    array:addObject(CCDelayTime:create(1 ) );
    array:addObject(CCMoveTo:create(3, ccp(-gap, self.m_label_task_y)));
    array:addObject(CCDelayTime:create(1 ) );
    array:addObject(CCMoveTo:create(3, ccp(0, self.m_label_task_y)));

    self._label_task:runAction(CCRepeatForever:create(CCSequence:create(array ) ) );
end

--endregion
