CHandleHint3D=class("CHandleHint3D",function() return ImageView:create() end)
local CSelfHandCard3D=require("src/Controls/3D/CSelfHandCard3D")
local the_path=""
local HandleHintDir = {left=1, right=2}
function CHandleHint3D:ctor(view_size)
    self._items_gang_wait={}
    self._items_gang_show={}
    self._view_size = view_size
    self._type=""
    self._cards={}
    --self._card_scale=1
    self._hint_count=0
    self._call_func=nil
    self._dir=HandleHintDir.left
    self._base_x = view_size.width * 0.5
    self._base_y = view_size.height * 0.5
    self:init()
end

function CHandleHint3D:init()
    self:setScale9Enabled(true)
    self._scale = 0.7
    self:setDir(HandleHintDir.left)
    self:setVisible(false)
end

function CHandleHint3D:setType(param_type)
    self._type=param_type
end

function CHandleHint3D:setDirLeft()
    self:setDir(HandleHintDir.left)
end

function CHandleHint3D:setDirRight()
    self:setDir(HandleHintDir.right)
end

function CHandleHint3D:setDir(dir)
    self._dir=dir
end

function CHandleHint3D:getHintCount()
    return self._hint_count
end

function CHandleHint3D:setController(controller)
    self._controller = controller
end

function CHandleHint3D:touchEvent(sender, touchType, card)
    if self._controller then
        self._controller:touchEvent(sender, touchType, card)
    end
end

function CHandleHint3D:addHintData(param_type,param_value)
    self._hint_count=self._hint_count+1
    if param_type==HandleType.b_gang or param_type==HandleType.d_gang or param_type==HandleType.a_gang then
        if not self._cards[self._hint_count] then
            self._cards[self._hint_count]=CSelfHandCard3D.new()
            self._cards[self._hint_count]:setController(self)
            self._cards[self._hint_count]:setScale(self._scale)
            self:addChild(self._cards[self._hint_count])
        end
        self._cards[self._hint_count]:setType(param_type)
        self._cards[self._hint_count]:setCardValue(param_value)
        self._cards[self._hint_count]:setMessageValue(param_value)
        --self._cards[self._hint_count]:setCanTouch(true)
    elseif param_type==HandleType.b_chi_left or param_type==HandleType.b_chi_mid or param_type==HandleType.b_chi_right then
        if not self._cards[(self._hint_count-1)*3+1] then
            for i=3*self._hint_count-2,3*self._hint_count,1 do
                self._cards[i]=CSelfHandCard3D.new()
                self._cards[i]:setController(self)
                self._cards[i]:setScale(self._scale)
                self:addChild(self._cards[i])
            end
        end

        local show_value=param_value
        if param_type==HandleType.b_chi_mid then show_value=show_value+1
        elseif param_type==HandleType.b_chi_left then show_value=show_value+2 end
        for i=3*self._hint_count-2,3*self._hint_count,1 do
            self._cards[i]:setType(param_type)
            self._cards[i]:setCardValue(show_value-(i-3*self._hint_count+2))
            self._cards[i]:setMessageValue(param_value)
            --self._cards[i]:setCanTouch(true)
            if LayoutConfig.show_chi_hint_mask then
                if show_value-(i-3*self._hint_count+2) == param_value then
                    self._cards[i]:showMask();
                else 
                    self._cards[i]:hideMask();
                end
            end
        end
    end
end

function CHandleHint3D:setBasePosition(pt)
    self._base_x = pt.x
    self._base_y = pt.y
end

function CHandleHint3D:showHint()
    local card_width = 80
    local card_height = 100
    if self._cards[1] then
        card_width = self._cards[1]:getSize().width
        card_height = self._cards[1]:getSize().height
    end
    if self._type=="gang" then
        self:setSize(CCSize((card_width+20)*self._scale*self._hint_count+10,(card_height)*self._scale+15))
    elseif self._type=="chi" then
        self:setSize(CCSize((card_width*3+20)*self._scale*self._hint_count+10,(card_height)*self._scale+15))
    end

    local str = ""
    if self._dir == HandleHintDir.left then
        -- 左边，箭头靠左，整体靠右
        str = "left"
    else
        -- 右边，箭头靠右，整体靠左
        str = "right"
    end
    self:loadTexture(the_path.."btn_handle_bg_hint_"..str..".png", 1)
    if self._dir == HandleHintDir.left then
        self:setPosition(ccp(self._base_x + self:getSize().width * 0.5 - 30, self._base_y + self:getSize().height * 0.5 + 5))
    else
        self:setPosition(ccp(self._base_x - self:getSize().width * 0.5 + 30, self._base_y + self:getSize().height * 0.5 + 5))
    end

    -- 重设位置，必须要到显示的时候才知道具体有几张牌要显示，所以在这里才确定位置
    if self._type=="gang" then
        for i=1,self._hint_count do
            local posx = -(2*i-1)*(card_width+20)*self._scale*0.5-5
            posx = posx + self:getSize().width*0.5
            local posy = 3
            self._cards[i]:setPosition(ccp(posx,posy))
        end
    elseif self._type=="chi" then
        for index=1,self._hint_count do
            local posx = -(2*index-1)*(card_width*3+20)*self._scale*0.5-5
            for i=3*index-2,3*index,1 do
                local posy = 3
                local temp_x=posx+(3*index-1-i)*(card_width-8)*self._scale
                temp_x = temp_x + self:getSize().width*0.5
                self._cards[i]:setPosition(ccp(temp_x,posy))
            end
        end
    end
    self:setCanTouch(true)
    self:setVisible(true)
end

function CHandleHint3D:hideHint(param_clear)
    if param_clear==true then
        self:clearData()
    end
    self:setVisible(false)
end

function CHandleHint3D:clearData()
    for i=1,self._hint_count,1 do
        self._cards[i]:hideCard()
    end
    self._hint_count=0
end

function CHandleHint3D:setCanTouch(param_touch)
    if self._type=="gang" then
        for i=1,self._hint_count,1 do
            self._cards[i]:setCanTouch(param_touch)
            self._cards[i]:showCard()
        end
        for i=self._hint_count+1,#self._cards,1 do
            self._cards[i]:hideCard()
        end
    elseif self._type=="chi" then
        for i=1,3*self._hint_count,1 do
            self._cards[i]:setCanTouch(param_touch)
            self._cards[i]:showCard()
        end
        for i=3*self._hint_count+1,#self._cards,1 do
            self._cards[i]:hideCard()
        end
    end
end

return CHandleHint3D