
--------------------------------------------------------------------------------
-- 辅助函数
--------------------------------------------------------------------------------
UIHelper = UIHelper or {}

--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------

function UIHelper.is_module()
    if get_module_mask then
        if bit._and(get_module_mask(), MASK_MODULE_WECHAT) > 0 then
            return true
        else
            return false
        end
    end
    return false
end

function UIHelper.is_module_shop()
    if get_module_mask then
        if bit._and(get_module_mask(), MASK_MODULE_SHOP) > 0 then
            return true
        else
            return false
        end
    end
    return false
end

function UIHelper.is_cheat()
    local c = require("cjson")
    local tbl_json = frame_tools:get_room_data()
    if tbl_json == nil then
        return false
    end
    if bit._and(tbl_json.room_kind, ROOM_KIND_LINEUP) > 0 then 
        return true
    end
    return false
 end 

function UIHelper.create_img(father, pos, file_info,texType, anchor)
    anchor = anchor or ccp(0.5, 0.5)
    texType = texType or 0
    local img = ImageView:create()
    if file_info ~= nil then
        img:loadTexture(file_info,texType)
    end
    img:setPosition(pos)
    father:addChild(img)
    img:setAnchorPoint(anchor)
    return img
end

function UIHelper.create_labelBM(father, file_info, pos, anchor)
    pos = pos or ccp(0, 0)
    anchor = anchor or ccp(0.5, 0.5)

    local label = LabelBMFont:create()
    label:setFntFile(file_info)
    label:setPosition(pos)
    label:setAnchorPoint(anchor)
    father:addChild(label)
    return label
end

function UIHelper.create_label(father, pos, size, color)
    color = color or ccc3(255, 255, 255)
    local label = Label:create()
    label:setFontSize(size)
    label:setPosition(pos)
    label:setColor(color)
    father:addChild(label)
    return label
end

function UIHelper.create_labelEx(father, pos, size, color)
    color = color or ccc3(255, 255, 255)
    local label = UILabelEx:create()
    label:setFontSize(size)
    label:setPosition(pos)
    label:setColor(color)
    label:setAnchorPoint(ccp(0, 0.5))
    father:addChild(label)
    return label
end

function UIHelper.create_btn(father, pos, file_info, texType, anchor)
    anchor = anchor or ccp(0.5, 0.5)
    texType = texType or 0
    local btn = UIButtonExSmall:create()
    if file_info ~= nil then
        btn:loadTextureNormal(file_info,texType)
    end
    btn:setPosition(pos)
    father:addChild(btn)
    btn:setAnchorPoint(anchor)
    return btn
end

function UIHelper.create_scroll(father,pos,size,direction)
    direction = direction or _G.SCROLLVIEW_DIR_VERTICAL
    local scroll=ScrollView:create();
    scroll:setDirection(direction)
    if pos then
        scroll:setPosition(pos);
    end
    if size then
        scroll:setSize(size);
    end
    father:addChild(scroll);
    return scroll;
end

function UIHelper.create_progress(father,pos,file,imgtype,type,reverse)
    type = type or _G.kCCProgressTimerTypeRadial
    
    local sprite = nil
    if imgtype == 1 then
    	sprite=CCSprite:createWithSpriteFrameName(file)
	else
		sprite=CCSprite:create(file)    
    end

    local progress=CCProgressTimer:create(sprite);
    progress:setType(type);
    if reverse then
        progress:setReverseProgress(reverse)
    end
    if pos then
        progress:setPosition(pos);
    end
    
    father:addNode(progress);
    return progress;
end


function UIHelper.game_user_head(father, pos, isTouch)
    isTouch = isTouch == nil and true or isTouch
    local head_btn = Button:create()
    head_btn:loadTextureNormal("transparent_back.png",1)
    head_btn:setScale9Enabled(true)
    head_btn:setTouchEnabled(isTouch)
    head_btn:setSize(CCSizeMake(80, 80))
    head_btn:setPosition(pos)

    head_btn.ui_head = UICustomImage:create()
    head_btn.ui_head:setPosition(ccp(0, 0))
    head_btn.ui_head:setTouchEnabled(false)
    head_btn:addChild(head_btn.ui_head)

    father:addChild(head_btn)
    return head_btn
end

function UIHelper.switch_to_view_id(chairid)
    if(chairid == -1) or not game_layer.isGetSeat then
        return -1;
    end

--    if game_layer.isCanChangeSeat then
        local viewGap = game_layer.table_user_seat[chairid + 1] - game_layer.selfSeat;
        local tableView = {1,2,3,4,1,2,3,4,1,2,3,4};
        local selfIndex = 7
        local viewid = tableView[selfIndex + viewGap];
        return viewid;
--    end
    
--    return switch_to_view_id(chairid) + 1
end

function UIHelper.switch_to_seat_id(viewid)
    if(viewid == -1) or not game_layer.isGetSeat then
        return -1;
    end

    local seatGap = viewid - VIEW_INDEX_SELF;

    local tableSeats = {0,1,2,3};
    local selfIndex = -1;
    for k,v in pairs(tableSeats) do
        if v == game_layer.selfSeat then
            selfIndex = k;
        end
    end
    tableSeats = {0,1,2,3,0,1,2,3,0,1,2,3};
    selfIndex = selfIndex + 4;

    local seatId = tableSeats[selfIndex + seatGap];
    
    return seatId;
end

function UIHelper.setBattary(battary)
    local battery_num = frame_tools:get_curr_battery()
    local index = 0
    if battery_num >= 76 then
        index = 1
    elseif battery_num >= 51 then
        index = 2
    elseif battery_num >= 26 then
        index = 3
    elseif battery_num >= 5 then
        index = 4
    else 
        index = 5
    end
    if index ~= game_layer.battery_num then
        game_layer.battery_num = index
        battary:setScaleX((6-index)/5)
    end
end

function UIHelper.setWifi(wifi)
    if game_layer.wifi_status ~= frame_tools:get_wifi_status() then
        game_layer.wifi_status = frame_tools:get_wifi_status()
        local wifi_or_not = frame_tools:get_wifi_status() == 0 and "signal.png" or "wifi.png"
        wifi:loadTexture(wifi_or_not,1)
    end
end

function UIHelper.get_postion(percent)
    local count, value = math.floor((1 - percent) * 360 / 45), (1 - percent) * 360 % 45
    local posX, posY = 0, 0
    local angle = count % 2 == 0 and value or 45 - value
    local length = math.tan(math.rad(angle)) * 63
    if count == 0 then
        posX = length
        posY = game_layer.player_clock:getContentSize().height/2-2
    elseif count == 1 then
        posX = game_layer.player_clock:getContentSize().width/2-2
        posY = length
    elseif count == 2 then
        posX = game_layer.player_clock:getContentSize().width/2-2
        posY = -length
    elseif count == 3 then
        posX = length
        posY = -(game_layer.player_clock:getContentSize().height/2-2)
    elseif count == 4 then
        posX = -length
        posY = -(game_layer.player_clock:getContentSize().height/2-2)
    elseif count == 5 then
        posX = -(game_layer.player_clock:getContentSize().width/2-2)
        posY = -length
    elseif count == 6 then
        posX = -(game_layer.player_clock:getContentSize().width/2-2)
        posY = length
    elseif count == 7 then
        posX = -length
        posY = game_layer.player_clock:getContentSize().height/2-2
    end
    return ccp(posX, posY)
end

function UIHelper.get_action(curr_time, total_time, percent)
    local array = CCArray:create()
    local valid_time = total_time - curr_time
    if percent > 7/8 then
        array:addObject(CCMoveTo:create(total_time/8 - valid_time, ccp(game_layer.player_clock:getContentSize().width/2 - 2, game_layer.player_clock:getContentSize().height/2 - 2)))
        array:addObject(CCMoveTo:create(total_time/4, ccp(game_layer.player_clock:getContentSize().width/2 - 2, -game_layer.player_clock:getContentSize().height/2 + 2)))
        array:addObject(CCMoveTo:create(total_time/4, ccp(-game_layer.player_clock:getContentSize().width/2 + 2, -game_layer.player_clock:getContentSize().height/2 + 2)))
        array:addObject(CCMoveTo:create(total_time/4, ccp(-game_layer.player_clock:getContentSize().width/2 + 2, game_layer.player_clock:getContentSize().height/2 - 2)))
        array:addObject(CCMoveTo:create(total_time/8, ccp(0, game_layer.player_clock:getContentSize().height/2 - 2)))
    elseif percent > 5/8 then
        array:addObject(CCMoveTo:create(total_time/4 - (valid_time - total_time / 8), ccp(game_layer.player_clock:getContentSize().width/2 - 2, -game_layer.player_clock:getContentSize().height/2 + 2)))
        array:addObject(CCMoveTo:create(total_time/4, ccp(-game_layer.player_clock:getContentSize().width/2 + 2, -game_layer.player_clock:getContentSize().height/2 + 2)))
        array:addObject(CCMoveTo:create(total_time/4, ccp(-game_layer.player_clock:getContentSize().width/2 + 2, game_layer.player_clock:getContentSize().height/2 - 2)))
        array:addObject(CCMoveTo:create(total_time/8, ccp(0, game_layer.player_clock:getContentSize().height/2 - 2)))
    elseif percent > 3/8 then
        array:addObject(CCMoveTo:create(total_time/4 - (valid_time - 3*total_time/8), ccp(-game_layer.player_clock:getContentSize().width/2 + 2, -game_layer.player_clock:getContentSize().height/2 + 2)))
        array:addObject(CCMoveTo:create(total_time/4, ccp(-game_layer.player_clock:getContentSize().width/2 + 2, game_layer.player_clock:getContentSize().height/2 - 2)))
        array:addObject(CCMoveTo:create(total_time/8, ccp(0, game_layer.player_clock:getContentSize().height/2 - 2)))
    elseif percent > 1/8 then
        array:addObject(CCMoveTo:create(total_time/4 - (valid_time - 5*total_time/8), ccp(-game_layer.player_clock:getContentSize().width/2 + 2, game_layer.player_clock:getContentSize().height/2 - 2)))
        array:addObject(CCMoveTo:create(total_time/8, ccp(0, game_layer.player_clock:getContentSize().height/2 - 2)))
    else
        array:addObject(CCMoveTo:create(total_time/8 - (valid_time - 7*total_time/8), ccp(0, game_layer.player_clock:getContentSize().height/2 - 2)))
    end
    return CCSequence:create(array)
end


function UIHelper.show_clock(viewid, time, isCallback, total_time)
    table_3d_layout:showTime(true)
    table_3d_layout:setTime(time,true)
    UIHelper.show_next_dir(viewid)
end


function UIHelper.set_game_clock()

end

function UIHelper.play_start_action(viewid)
    UIHelper.set_game_clock()
            
    UIHelper.convert_east_banker(viewid)
    UIHelper.show_dice_animate()
end

function UIHelper.show_dice_animate()
    audio_engine.playEffect(KindSound.dice)
    UIHelper.convert_east_banker(game_layer.banker_viewid)

    if #game_layer.tou_zi < 2 then
        return;
    end

    frame_tools:pause_message()

    local count = 0
    local function callback2()
        for i=1, 2 do
            game_layer.tou_zi[i]:setVisible(false)
        end
        
        frame_tools:restore_message()
        UIHelper.show_direction_light(3,game_layer.banker_viewid)
    end

    local function callback1()
        for i=1, 2 do
            local tou_zi_count = 6 * (i-1);
            game_layer.tou_zi[i]:getAnimation():playWithIndex(game_layer.dice_tbl[i] - 1 + tou_zi_count)
            game_layer.tou_zi[i]:setVisible(true)
        end
    end

    local array = CCArray:create()
    array:addObject(CCCallFunc:create(callback1))
    array:addObject(CCDelayTime:create(2))
    array:addObject(CCCallFunc:create(callback2))

    game_layer.tou_zi[1]:runAction(CCSequence:create(array))
end

function UIHelper.convert_east_banker(viewid)
    UIHelper.show_direction_light(3,game_layer.banker_viewid)   
end

function UIHelper.Switch_view_to_view(viewid)
    if viewid == -1 then
        return -1;
    end
    local int_veiw = viewid;
    return 5 - int_veiw;
end

function UIHelper.show_direction_light(viewid,true_view)
    table_3d_layout:turnOffAllLight();
    table_3d_layout:turnOffAll();
    table_3d_layout:lightLightDirection(UIHelper.Switch_view_to_view(true_view));
    table_3d_layout:lightDirection(UIHelper.Switch_view_to_view(true_view)) 
end

function UIHelper.convert_direction(viewid)
    local show_id = 3 + game_layer.banker_viewid - viewid
    show_id = show_id == 0 and 4 or show_id
    return show_id
end

function UIHelper.show_next_dir(viewid)
    UIHelper.show_direction_light(0,viewid)
end

function UIHelper.clear_data()
    game_layer.game_user:clear_user_data()
end

function UIHelper.show_action_result(kind, viewid,soundid)
    local pos = {ccp(game_layer.visibleSize.width/2, game_layer.visibleSize.height - 220), 
                    ccp(game_layer.visibleSize.width/2 + 200, game_layer.visibleSize.height/2), 
                    ccp(game_layer.visibleSize.width/2, 220),
                    ccp(game_layer.visibleSize.width/2 - 200, game_layer.visibleSize.height/2)}

    audio_engine.playCardVoice(soundid,switch_to_chair_id(viewid-1));

    local function animationEvent(armatureBack, movementType, movementID)
        print("movementType = ", movementType)
        if movementType ~= 0 then
            game_layer.peng_gang_hu:setVisible(false)
        end
    end

end

