
--------------------------------------------------------------------------------
-- 音效相关辅助函数
--------------------------------------------------------------------------------
audio_engine = audio_engine or {}

--------------------------------------------------------------------------------
-- 常量
--------------------------------------------------------------------------------
audio_engine.audioengine = nil
--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------

-- 播放背景音乐
function audio_engine.playBackground(musicPath)
	if audio_engine.audioengine == nil then
		audio_engine.audioengine = SimpleAudioEngine:sharedEngine()
	end
	local bgMusicPath = CCFileUtils:sharedFileUtils():fullPathForFilename("resources/sound/" .. musicPath .. ".mp3") 
    audio_engine.audioengine:playBackgroundMusic(bgMusicPath, true)
end

-- 停止播放背景音乐
function audio_engine.endBackground()
	if audio_engine.audioengine == nil then
		audio_engine.audioengine = SimpleAudioEngine:sharedEngine()
	end
	audio_engine.audioengine:stopBackgroundMusic()
end

function audio_engine.stopEffect(id)
	if audio_engine.audioengine == nil then
		audio_engine.audioengine = SimpleAudioEngine:sharedEngine()
	end
	audio_engine.audioengine:stopEffect(id)
end

function audio_engine.stopAllEffects()
    if audio_engine.audioengine == nil then
        audio_engine.audioengine = SimpleAudioEngine:sharedEngine()
    end
    audio_engine.audioengine:stopAllEffects()
end

-- 播放特效
function audio_engine.playEffect(id)   
	if audio_engine.audioengine == nil then
		audio_engine.audioengine = SimpleAudioEngine:sharedEngine()
	end

    if id == -1 then
        audio_engine.audioengine:playEffect("resources/sound/click.mp3")
        return
    end
    
    if id == KindSound.start then
        game_layer.send_cards_effectid = audio_engine.audioengine:playEffect("resources/sound/get_hand_cards.mp3", true)
    elseif id == KindSound.dice then
        audio_engine.audioengine:playEffect("resources/sound/dice.mp3")
    elseif id == KindSound.gang then
        audio_engine.audioengine:playEffect("resources/sound/ex_gang.mp3")
    elseif id == KindSound.peng then
        audio_engine.audioengine:playEffect("resources/sound/ex_peng.mp3")
    elseif id == KindSound.catch_card then
        audio_engine.audioengine:playEffect("resources/sound/get_a_hand_card.mp3")
    elseif id == KindSound.chi then
        audio_engine.audioengine:playEffect("resources/sound/ex_chi.mp3")
    elseif id == KindSound.hu then
        audio_engine.audioengine:playEffect("resources/sound/ex_peng.mp3")
    elseif id == KindSound.win then
        audio_engine.audioengine:playEffect("resources/sound/win.mp3")
    elseif id == KindSound.lose then
        audio_engine.audioengine:playEffect("resources/sound/lose.mp3")
    elseif id == KindSound.draw then
        audio_engine.audioengine:playEffect("resources/sound/liuju.mp3")
    elseif id == KindSound.outcards then
        audio_engine.audioengine:playEffect("resources/sound/out_cards.mp3")
    elseif id == KindSound.time_soon then
        audio_engine.audioengine:playEffect("resources/sound/time_soon.mp3")
    elseif id == KindSound.shudian then
        audio_engine.audioengine:playEffect("resources/sound/shudian.mp3")
    elseif id == KindSound.huandian then
        audio_engine.audioengine:playEffect("resources/sound/huandian.mp3")
    end	
end

-- 播放特效
function audio_engine.playCardVoice(id, chair_id)   
	if audio_engine.audioengine == nil then
		audio_engine.audioengine = SimpleAudioEngine:sharedEngine()
	end

    if id == -1 then
        audio_engine.audioengine:playEffect("resources/sound/click.mp3")
        return
    end

	local c = require "cjson"
    local table_json = frame_tools:get_user_data(chair_id);
    if table_json == nil then
        return;
    end
    if (table_json.sex==0) then
        audio_engine.audioengine:playEffect("resources/sound/nv/"..id..".mp3")
    elseif (table_json.sex==1) then
        audio_engine.audioengine:playEffect("resources/sound/nan/"..id..".mp3")    
    end
end

function audio_engine.playGiftEffect(id)
    if id < 0 or id > 4 then
        return 
    end
    if audio_engine.audioengine == nil then
        audio_engine.audioengine = SimpleAudioEngine:sharedEngine()
    end  
    audio_engine.audioengine:playEffect("resources/sound/gift/sound_index" .. id .. ".mp3")  
end

function audio_engine.enter_effect()
    if audio_engine.audioengine == nil then
        audio_engine.audioengine = SimpleAudioEngine:sharedEngine()
    end    
    audio_engine.audioengine:playEffect("resources/sound/player_in.mp3")
end

function audio_engine.left_effect()
    if audio_engine.audioengine == nil then
        audio_engine.audioengine = SimpleAudioEngine:sharedEngine()
    end    
    audio_engine.audioengine:playEffect("resources/sound/player_out.mp3")
end

function audio_engine.ready_effect()
    if audio_engine.audioengine == nil then
        audio_engine.audioengine = SimpleAudioEngine:sharedEngine()
    end 
    audio_engine.audioengine:playEffect("resources/sound/ready.mp3")  
end

function audio_engine.hit_card_effect()
    if audio_engine.audioengine == nil then
        audio_engine.audioengine = SimpleAudioEngine:sharedEngine()
    end 
    audio_engine.audioengine:playEffect("resources/sound/hit_card.mp3")  
end

function audio_engine.heap_out_card_effect()
    if audio_engine.audioengine == nil then
        audio_engine.audioengine = SimpleAudioEngine:sharedEngine()
    end 
    audio_engine.audioengine:playEffect("resources/sound/heap_out_card.mp3")  
end