--------------------------------------------------------------------------------
-- 退出界面
--------------------------------------------------------------------------------
back_layer = class("back_layer")

function back_layer.extend(target)
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target, t)
	end
	setmetatable(t, back_layer)
	return target
end

--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------

function back_layer:hide_back_layer()
	self._runing=true
    local array=CCArray:create()
--    array:addObject(CCScaleTo:create(0.1,1.1))
    array:addObject(CCScaleTo:create(0.1,0))
    array:addObject(CCCallFunc:create(function()
         self.btn_no:setTouchEnabled(false)
         self.btn_yes:setTouchEnabled(false)
         self:setTouchEnabled(false)
         self:setVisible(false)
         self._runing=false
    end))
    local action=CCSequence:create(array)
    self.bg_form:stopAllActions()
    self.bg_form:runAction(action)
end

function back_layer:show_back_layer()
	self.bg_form:setScale(0)
	self:setVisible(true)
	self:setTouchEnabled(true)
	self._runing=true
	local array=CCArray:create()
--	array:addObject(CCScaleTo:create(0.2,1.1))
--	array:addObject(CCScaleTo:create(0.1,0.9))
	array:addObject(CCScaleTo:create(0.1,1))
	array:addObject(CCCallFunc:create(function()
		self.btn_no:setTouchEnabled(true)
		self.btn_yes:setTouchEnabled(true)
		self._runing=false
	end))
	local action=CCSequence:create(array)
	self.bg_form:stopAllActions()
	self.bg_form:runAction(action)
end

function back_layer:init(visibleSize)
	self.back_ground = ImageView:create()
	self.back_ground:loadTexture("bg_black.png",1)
	self.back_ground:setScale9Enabled(true)
	self.back_ground:setAnchorPoint(ccp(0, 0))
	self.back_ground:setSize(visibleSize)
	self:addChild(self.back_ground)

	self.bg_form = UIHelper.create_img(self.back_ground, ccp(visibleSize.width/2, visibleSize.height/2), "resources/bg_form.png")

	local img_hint = UIHelper.create_img(self.bg_form, ccp(0, self.bg_form:getSize().height/2 - 50), "img_hint.png",1)

	local label_hint  = UIHelper.create_label(self.bg_form, ccp(0, 0), 30, ccc3(131,105,82))
	label_hint:setText("当前正在游戏中，是否返回大厅？")

	self.btn_yes = UIHelper.create_btn(self.bg_form, ccp(-150, -140), "btn_yes.png",1)

	self.btn_no = UIHelper.create_btn(self.bg_form, ccp(150, -140), "btn_no.png",1)

    local function touch_event()
		on_btn_return_ok()
    end
    self.btn_yes:addTouchEventListener(touch_event)


    local function touchEvent()
		self:hide_back_layer()
    end
    self.btn_no:addTouchEventListener(touchEvent)
--    self:addTouchEventListener(touchEvent)
end

function back_layer:create(visibleSize)
	local layer = back_layer.extend(Layout:create())
	layer:setSize(visibleSize)
	layer:setVisible(false)
	layer:setTouchEnabled(false)
	layer:init(visibleSize)
	return layer
end





-----------------------------------------------------------------------------------------
--好友房解散提示
-----------------------------------------------------------------------------------------
dissolve_layer = class("dissolve_layer");

function dissolve_layer.extend(target)
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target, t)
	end
	setmetatable(t, dissolve_layer)
	return target
end

function dissolve_layer:create(visibleSize)
	local layer = dissolve_layer.extend(Layout:create())
	layer:setSize(visibleSize)
	layer:setVisible(false)
	layer:setTouchEnabled(false)
	layer:init(visibleSize)
	return layer
end

function dissolve_layer:hideLayer()
	self._runing=true
    local array=CCArray:create()
--    array:addObject(CCScaleTo:create(0.1,1.1))
    array:addObject(CCScaleTo:create(0.1,0))
    array:addObject(CCCallFunc:create(function()
         self.btn_no:setTouchEnabled(false)
         self.btn_yes:setTouchEnabled(false)
         self:setTouchEnabled(false)
         self:setVisible(false)
         self._runing=false
    end))
    local action=CCSequence:create(array)
    self.bg_form:stopAllActions()
    self.bg_form:runAction(action)
end

function dissolve_layer:showLayer()
	self.bg_form:setScale(0)
	self:setVisible(true)
	self:setTouchEnabled(true)
	self._runing=true
	local array=CCArray:create()
--	array:addObject(CCScaleTo:create(0.2,1.1))
--	array:addObject(CCScaleTo:create(0.1,0.9))
	array:addObject(CCScaleTo:create(0.1,1))
	array:addObject(CCCallFunc:create(function()
		self.btn_no:setTouchEnabled(true)
		self.btn_yes:setTouchEnabled(true)
		self._runing=false
	end))
	local action=CCSequence:create(array)
	self.bg_form:stopAllActions()
	self.bg_form:runAction(action)
end

function dissolve_layer:init(visibleSize)
	self.back_ground = ImageView:create()
	self.back_ground:loadTexture("bg_black.png",1)
	self.back_ground:setScale9Enabled(true)
	self.back_ground:setAnchorPoint(ccp(0, 0))
	self.back_ground:setSize(visibleSize)
	self:addChild(self.back_ground)

	self.bg_form = UIHelper.create_img(self.back_ground, ccp(visibleSize.width/2, visibleSize.height/2), "resources/bg_form.png")
    self.bg_form:setScale(0.88);

	local img_hint = UIHelper.create_img(self.bg_form, ccp(0, self.bg_form:getSize().height/2 - 50), "img_hint.png",1)

	local label_hint  = UIHelper.create_label(self.bg_form, ccp(0, 30), 30, ccc3(131,105,82))
	label_hint:setText("本局有玩家长时间未操作,")
    local label_hint1  = UIHelper.create_label(self.bg_form, ccp(0, 0), 30, ccc3(131,105,82))
	label_hint1:setText("确认是否要解散？")
    local label_hint2  = UIHelper.create_label(self.bg_form, ccp(0, -30), 30, ccc3(131,105,82))
	label_hint2:setText("(60秒后，系统自动确认解散)")

	self.btn_yes = UIButtonExSmall:create();
    self.btn_yes:loadTextureNormal("btn_yes.png", 1)
    self.btn_yes:setPosition(ccp(-150, -140))
    self.bg_form:addChild(self.btn_yes)
    self.btn_yes:addTouchEventListener(function() self:OnBtnYes() end)

	self.btn_no = UIButtonExSmall:create();
    self.btn_no:loadTextureNormal("btn_no.png", 1)
    self.btn_no:setPosition(ccp(150, -140))
    self.bg_form:addChild(self.btn_no)
    self.btn_no:addTouchEventListener(function() self:OnBtnNo() end)
end

function dissolve_layer:OnBtnYes()
    frame_tools:send_data(MessageType.SUB_C_DISSOLVE_YES,"");
    self:hideLayer();
end

function dissolve_layer:OnBtnNo()
    self:hideLayer();
end
