--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

--------------------------------------------------------------------------------
-- 卡牌界面
--------------------------------------------------------------------------------
card_layer = class("card_layer")

function card_layer.extend(target)
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target, t)
	end
	setmetatable(t, card_layer)
	return target
end

function card_layer:create(visibleSize)
    local layer = card_layer.extend(Layout:create())
    if layer ~= nil then
        layer:init(visibleSize)
    end

    return layer
end

--------------------------------------------------------------------------------
-- 属性
--------------------------------------------------------------------------------
card_layer.hand_cards=nil           --手牌
card_layer.hua_cards=nil            --花牌

card_layer.animation_bu_hua={}      --补花

card_layer.int_hand_card_group={}

card_layer.table_big_card={}
card_layer.point_out_cards={}
--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------
function card_layer:init( visibleSize ) 
    self.visibleSize = visibleSize;
    self.int_zorder_bu_hua = 1000000;

    self:setSize(visibleSize)
    self.visible_size=visibleSize

    local offset = 290 + game_layer.screenGap + 50;
    self.point_out_cards[4] = ccp(offset, visibleSize.height / 2 + 50);
	self.point_out_cards[3] = ccp(visibleSize.width / 2, visibleSize.height / 2 - 70);
	self.point_out_cards[2] = ccp(visibleSize.width - offset, visibleSize.height / 2 + 50);
	self.point_out_cards[1] = ccp(visibleSize.width / 2, visibleSize.height / 2  + 130);

    self.point_bu_hua = {
    ccp(visibleSize.width / 2 , visibleSize.height - 150),
    ccp(visibleSize.width - (offset - 50), visibleSize.height / 2 + 30), 
    ccp(visibleSize.width/2, 200), 
    ccp((offset - 50), visibleSize.height / 2 + 30)
    }
    self.point_kaijin = {
    ccp(visibleSize.width / 2 , visibleSize.height - 180),
    ccp(visibleSize.width - (offset - 10), visibleSize.height / 2 + 15), 
    ccp(visibleSize.width/2, 180), 
    ccp((offset - 10), visibleSize.height / 2 + 15)
    }

    self.hand_cards={};
    self.hua_cards={};
    self.table_big_card={}
    for i=1,VIEW_INDEX_COUNT,1 do  
        table.insert(self.hand_cards, {})  
        table.insert(self.hua_cards, {})           

        table.insert(self.int_hand_card_group,0);

        local big_card = big_card_sprite:create()
        self:addChild(big_card);
        big_card:setPosition(self.point_out_cards[i]);
        big_card:setScale(0.85);
        big_card:setZOrder(10000);

        table.insert(self.table_big_card,big_card)
    end



    cards_3d_layout:setOutCardEndFunc(function (e_index,pos)
        self:play_point(e_index,pos)
    end);
    cards_3d_layout:setClickCardOutFunc(function(param)      
        self:out_card(param)
    end)
    cards_3d_layout:setMoveCardOutFunc(function(param)
        self:out_card(param)
    end)
    cards_3d_layout:setSortCardsFunc(function(param_list)
        return game_layer.sort_cards_by_size(param_list,#param_list,game_layer.byte_caishen_card)
    end) 
    cards_3d_layout:setFindCardInHandPositionFunc(function(cards,value)
        return self:find_new_card_index(cards,value);
    end) 
end

function card_layer:touch_event(sender, eventType)
    if eventType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end

    local touch_point = sender:getTouchEndPos();
    if touch_point.y > 200 then
        cards_3d_layout:unselectAllHandCards();
    end
end

function card_layer:out_card(card)
    cards_3d_layout:setHandCardsCanTouch(true)
    
    game_layer.other_turn();

    local cjson = require "cjson";
	local tbl = {}
    tbl.out_card = card
    frame_tools:send_data(MessageType.SUB_C_OUTCARD, tbl)

    audio_engine.playEffect(KindSound.outcards)
    audio_engine.playCardVoice(card, frame_tools:get_self_chair_id());

    game_layer.client_out_card = card;

    self:set_big_card(VIEW_INDEX_SELF,card);
end

function card_layer:set_big_card(int_view, card)
    for i=1,GAME_PLAYER,1 do
        self.table_big_card[int_view]:setVisible(false);
    end

    self.table_big_card[int_view]:set_card(card);

    self.table_big_card[int_view]:setOpacity(255);
    self.table_big_card[int_view].ptr_card:setCardOpacity(255);

    self.table_big_card[int_view]:setVisible(true);
end

function card_layer:hide_big_card(int_view_id)
    if int_view_id>VIEW_INDEX_COUNT or int_view_id<1 then 
        return
    end 
    self.table_big_card[int_view_id]:stopAllActions();
    self.table_big_card[int_view_id].ptr_card:stopAllActions();

    local array = CCArray:create();
    local callback = CCCallFunc:create(function()
        self.table_big_card[int_view_id].ptr_card:fadeOut(0.1);
    end);
    array:addObject(CCDelayTime:create(2));
    array:addObject(callback);
    array:addObject(CCFadeOut:create(0.1));

    self.table_big_card[int_view_id]:runAction(CCSequence:create(array));
end

function card_layer:clear_out_cards()
    for i=1,GAME_PLAYER,1 do
        self.table_big_card[i]:stopAllActions();
        self.table_big_card[i].ptr_card:stopAllActions();
        self.table_big_card[i]:setVisible(false);
    end
end

function card_layer:clear_out_card(int_view_id)
    if int_view_id>VIEW_INDEX_COUNT or int_view_id<1 then 
        return
    end 
    self.table_big_card[int_view_id]:stopAllActions();
    self.table_big_card[int_view_id].ptr_card:stopAllActions();
    self.table_big_card[int_view_id]:setVisible(false)
end

function card_layer:get_out_card(int_view)
    if self.table_big_card[int_view] == nil or not self.table_big_card[int_view]:isVisible() then
        return 0;
    end
    return self.table_big_card[int_view]:get_card();
end

function card_layer:play_point(int_view_id,pos)
    audio_engine.heap_out_card_effect();
    cards_3d_layout:showLastOutCardIndicator(int_view_id);

end

function card_layer:hide_point()
    if self.sprite_point~=nil then
        self.sprite_point:setVisible(false)
    end
    
    cards_3d_layout:showLastOutCardIndicator(0)
end

function card_layer:set_self_hand_card(hand_card,card_count,bool_ani,isReconnect)
    if bool_ani then
        local int_time = 0.5;
        self.int_hand_card_group[VIEW_INDEX_SELF] = 0   

        local function show_card(v)
            self.int_hand_card_group[VIEW_INDEX_SELF] = self.int_hand_card_group[VIEW_INDEX_SELF] + 1;    
            cards_3d_layout:setHandCards(UserIndex.down,hand_card,4*card_layer.int_hand_card_group[VIEW_INDEX_SELF]);

            audio_engine.audioengine:playEffect("resources/sound/get_hand_cards.mp3")
        end

        local array = CCArray:create()
        array:addObject(CCDelayTime:create(int_time))
        array:addObject(CCCallFuncN:create(show_card))
        array:addObject(CCDelayTime:create(int_time))
        array:addObject(CCCallFuncN:create(show_card))
        array:addObject(CCDelayTime:create(int_time))
        array:addObject(CCCallFuncN:create(show_card))
        array:addObject(CCDelayTime:create(int_time))
        array:addObject(CCCallFuncN:create(show_card))
        self:runAction(CCSequence:create(array));
    else
        if card_count%3 == 2 and isReconnect == true then
            game_layer.sort_cards_by_size(hand_card,card_count-1,game_layer.byte_caishen_card);
        else
            game_layer.sort_cards_by_size(hand_card,card_count,game_layer.byte_caishen_card);
        end
      
        cards_3d_layout:setHandCards(UserIndex.down,hand_card);
    end
    
    self.hand_cards[VIEW_INDEX_SELF] = hand_card;
end

function card_layer:showAniShuShan(param_viewid,view_from)
    if not self.spriteShuLei then
        self.spriteShuLei = CCSprite:create()
        self.spriteShuLei:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height/2))
        self:addNode(self.spriteShuLei);
        self.spriteShuLei:setAnchorPoint(ccp(0.5,0.16));
    end

    local aniShuLei = CCAnimation:create();
    for i=1,12 do
        local sprite = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("FX_SD_"..i..".png");
        aniShuLei:addSpriteFrame(sprite);
    end
    aniShuLei:setDelayPerUnit(0.1);
    aniShuLei:setRestoreOriginalFrame(true);
    local animaShuLei = CCAnimate:create(aniShuLei)

    local pos = {}
    if view_from ~= -1 then
        pos = cards_3d_layout:getLastVisibleCardInfo(view_from, LayoutCardsType.out)
        if pos == nil then return; end
    else
        pos = cards_3d_layout:getLastVisibleCardInfo(param_viewid, LayoutCardsType.hand)
        if pos == nil then return; end
        if param_viewid == UserIndex.left or param_viewid == UserIndex.right then
            pos.x = pos.x - 45;
            pos.y = pos.y + 15;
        end
    end

    local scale_table={0.8,0.7,0.6,0.5}
    local scale_index = 4;
    if pos.y < self.visibleSize.height/4 then
        scale_index = 1;
    elseif pos.y < self.visibleSize.height/2 then
        scale_index = 2;
    elseif pos.y < self.visibleSize.height*3/4 then
        scale_index = 3;
    else 
        scale_index = 4;
    end
    self.spriteShuLei:setScale(scale_table[scale_index]);
    self.spriteShuLei:setPosition(ccp(pos.x,pos.y));

    local array = CCArray:create();
    array:addObject(animaShuLei);
 
    self.spriteShuLei:runAction(CCSequence:create(array));
    audio_engine.playEffect(KindSound.shudian)
end

function card_layer:showAniQuanShan(param_viewid, waitTime)
    if not self.spriteQuanLei then
        self.spriteQuanLei = CCSprite:create()
        self.spriteQuanLei:setPosition(ccp(self.visibleSize.width/2, self.visibleSize.height/2))
        self:addNode(self.spriteQuanLei);
    end

    local aniQuanLei = CCAnimation:create();
    for i=1,8 do
        local sprite = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("hupai_diansi"..i..".png");
        aniQuanLei:addSpriteFrame(sprite);
    end
    aniQuanLei:setDelayPerUnit(0.1);
    aniQuanLei:setRestoreOriginalFrame(true);
    local animaQuanLei = CCAnimate:create(aniQuanLei)

    local pos = {}
    pos = cards_3d_layout:getLastVisibleCardInfo(param_viewid, LayoutCardsType.hand)
    if pos == nil then return; end
    if param_viewid == UserIndex.left or param_viewid == UserIndex.right then
        pos.x = pos.x - 50;
        pos.y = pos.y + 10;
    end

    local scale_table={1.6,1.0,0.9,0.7}
    local scale_index = 4;
    if param_viewid == UserIndex.down then
        scale_index = 1;
    elseif param_viewid == UserIndex.left then
        scale_index = 2;
    elseif param_viewid == UserIndex.right then
        scale_index = 3;
    else 
        scale_index = 4;
    end
    self.spriteQuanLei:setScale(scale_table[scale_index]);
    self.spriteQuanLei:setPosition(ccp(pos.x,pos.y));

    self.spriteQuanLei:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(waitTime),animaQuanLei) );
    audio_engine.playEffect(KindSound.huandian)
end

function card_layer:showHandleAni_old(param_viewid,view_from,index)
    if not self.animation_hu then 
        self.animation_hu = CCArmature:create("dh_mj_hupai")
        if not self.animation_hu then
            return;
        end
        self.animation_hu:setAnchorPoint(ccp(0.5,0))
        self.animation_hu:setZOrder(1000)
        self:addNode(self.animation_hu)
        self.animation_hu:setVisible(false)
    end
    
    local scale_table={0.6,0.5,0.4,0.3}
--    local scaleY_table={1,1,0.5,0.5};

    local pos = {}
    if view_from ~= -1 then
        pos = cards_3d_layout:getLastVisibleCardInfo(view_from, LayoutCardsType.out)
        if pos == nil then
            return;
        end
        pos.y = pos.y - 50;
    else
        self.animation_hu:setScale(scale_table[param_viewid])
        pos = cards_3d_layout:getLastVisibleCardInfo(param_viewid, LayoutCardsType.hand)
        pos.y = pos.y - 20;
        if param_viewid == UserIndex.left then
            pos.x = pos.x - 40
            pos.y = pos.y - 20;
        elseif param_viewid == UserIndex.down then
             pos.y = pos.y - 20;
        elseif param_viewid == UserIndex.right then
            pos.x = pos.x - 55
        end
    end

    if pos then
        local scale_index = 4;
        if pos.y < self.visibleSize.height/4 then
            scale_index = 1;
        elseif pos.y < self.visibleSize.height/2 then
            scale_index = 2;
        elseif pos.y < self.visibleSize.height*3/4 then
            scale_index = 3;
        else 
            scale_index = 4;
        end
        self.animation_hu:setScale(scale_table[scale_index])
--        self.animation_hu:setScaleY(scaleY_table[scale_index])

        self.animation_hu:setPosition(ccp(pos.x,pos.y))
        local array = CCArray:create();
            array:addObject(CCDelayTime:create(0.8));
            array:addObject(CCCallFunc:create(function(args)
                self.animation_hu:setVisible(true)
                self.animation_hu:getAnimation():play("dh_mj_hupai",-1,-1,-1,-1)
            end))
        self.animation_hu:runAction(CCSequence:create(array));
        if view_from ~= -1 then
            local array = CCArray:create();
            array:addObject(CCDelayTime:create(1.5));
            array:addObject(CCCallFunc:create(function(args)
                cards_3d_layout:removeOutCard(view_from)
                self:hide_point();
            end))
            self.animation_hu:runAction(CCSequence:create(array));            
        end
    else
        self.animation_hu:setVisible(false)
    end
end

function card_layer:player_qiangjin(param_viewid)
    if not self.animation_qiangjin then
        self.animation_qiangjin = CCArmature:create("fuzhoumajiang_animation");
        if not self.animation_qiangjin then
            return;
        end
        self.animation_qiangjin:setZOrder(self.int_zorder_bu_hua + 1)
        self:addNode(self.animation_qiangjin)
    end
    self.animation_qiangjin:setPosition(self.point_bu_hua[param_viewid]);

    self.animation_qiangjin:getAnimation():play("fuzhou_qiangjin",-1,-1,-1,-1);
end

function card_layer:player_lianzhuang(param_viewid)
    if not self.animation_lianzhuang then
        self.animation_lianzhuang = CCArmature:create("fuzhoumajiang_animation");
        if not self.animation_lianzhuang then
            return;
        end
        self.animation_lianzhuang:setZOrder(self.int_zorder_bu_hua + 1)
        self:addNode(self.animation_lianzhuang)
    end
    self.animation_lianzhuang:setPosition(self.point_bu_hua[param_viewid]);

    self.animation_lianzhuang:getAnimation():play("fuzhou_lianzhuang",-1,-1,-1,-1);
end

function card_layer:player_kaijin(param_viewid)
    if not self.animation_kaijin then
        self.animation_kaijin = CCArmature:create("fuzhoumajiang_animation");
        if not self.animation_kaijin then
            return;
        end
        self.animation_kaijin:setZOrder(self.int_zorder_bu_hua + 1)
        self:addNode(self.animation_kaijin)
    end
    self.animation_kaijin:setPosition(self.point_kaijin[param_viewid]);

    game_layer.caishen_img:setPosition(ccp(self.point_kaijin[param_viewid].x , self.point_kaijin[param_viewid].y + 80));
    
    self.animation_kaijin:getAnimation():play("fuzhou_kaijin",-1,-1,-1,-1);

--[[    local array=CCArray:create();
    array:addObject(CCCallFunc:create(function ()
        frame_tools:pause_message();
    end))
    array:addObject(CCDelayTime:create(1.5));
    array:addObject(CCCallFunc:create(function ()
        frame_tools:restore_message();
    end))
    self.animation_kaijin:runAction(CCSequence:create(array));
    ]]
end

function card_layer:set_other_hand_card(int_view_id,card_count,eye_card,bool_an_pai,bool_ani)
    local table_cards={};
    for i=1,card_count,1 do
        table.insert(table_cards,0);
    end

    local card_count=#table_cards;

    if bool_ani then
        local int_time = 0.5;
        card_layer.int_hand_card_group[int_view_id] = 0       
               
        local function show_card(v)
            card_layer.int_hand_card_group[int_view_id] = card_layer.int_hand_card_group[int_view_id] + 1;    
            cards_3d_layout:setHandCards(UIHelper.Switch_view_to_view(int_view_id),table_cards,4*card_layer.int_hand_card_group[int_view_id]);

--            audio_engine.audioengine:playEffect("resources/sound/get_hand_cards.mp3")
        end

        local array = CCArray:create()
        array:addObject(CCDelayTime:create(int_time))
        array:addObject(CCCallFuncN:create(show_card))
        array:addObject(CCDelayTime:create(int_time))
        array:addObject(CCCallFuncN:create(show_card))
        array:addObject(CCDelayTime:create(int_time))
        array:addObject(CCCallFuncN:create(show_card))
        array:addObject(CCDelayTime:create(int_time))
        array:addObject(CCCallFuncN:create(show_card))
        self:runAction(CCSequence:create(array));
    else
        cards_3d_layout:setHandCards(UIHelper.Switch_view_to_view(int_view_id),table_cards);
    end
end

function card_layer:do_bu_hua(int_view,hua_card)
    self:do_bu_hua_active(int_view);    
    cards_3d_layout:buHua(UIHelper.Switch_view_to_view(int_view),hua_card);
end

function card_layer:set_bu_hua(int_view,hua_cards,cards_count,bool_ref,bool_kaijin)

    cards_3d_layout:setHuaCards(UIHelper.Switch_view_to_view(int_view),hua_cards);
    
    if not bool_ref then
        return;
    end
    if not bool_kaijin then
        self:do_bu_hua_active(int_view);
    end
end

function card_layer:do_bu_hua_active(int_view)
 --播放动画、音效
    if not self.animation_bu_hua[int_view] then
        self.animation_bu_hua[int_view]=CCArmature:create("dh_jn_minglou")
        if not self.animation_bu_hua[int_view] then
            return;
        end
        self.animation_bu_hua[int_view]:setPosition(self.point_bu_hua[int_view])
        self.animation_bu_hua[int_view]:setScale(0.7)
        self.animation_bu_hua[int_view]:setZOrder(self.int_zorder_bu_hua)
        self:addNode(self.animation_bu_hua[int_view])
    end
    self.animation_bu_hua[int_view]:getAnimation():stop();
    self.animation_bu_hua[int_view]:getAnimation():playWithIndex(1,-1,-1,0);

    local function animation_end()
--        frame_tools:restore_message();
    end

    local array = CCArray:create()
    array:addObject(CCDelayTime:create(1))
    array:addObject(CCCallFunc:create(animation_end))
    self:runAction(CCSequence:create(array));

--    frame_tools:pause_message();
end

function card_layer:get_card_index(card_value)
    if self.hand_cards[VIEW_INDEX_SELF] == nil then
        return 1;
    end

    local int_index = 1;
    for k,v in pairs(self.hand_cards[VIEW_INDEX_SELF]) do
        local card = self.hand_cards[VIEW_INDEX_SELF][k]
        if card_value == card then
            int_index = k;
        end
    end

    if int_index > 17 then
        int_index = 1;
    end

    return int_index;
end

function card_layer:find_new_card_index(cards,value)
    if value == game_layer.byte_caishen_card then
        return 1;   
    end
    local cards_table=cards;
    table.insert(cards_table,value);
    game_layer.sort_cards_by_size(cards_table,#cards_table,game_layer.byte_caishen_card);
    
    for k,v in pairs(cards_table) do
        local card = cards_table[k]
        if value == card then
            return k;
        end
    end
    return 1;
end

function card_layer:get_cards_count()
    if self.hand_cards[VIEW_INDEX_SELF] == nil then
        return 0
    end
    local count = 0
    for k, v in pairs(self.hand_cards[VIEW_INDEX_SELF]) do
        if v then
            count = count + 1
        end
    end

    return count
end

function card_layer:get_hand_cards()
    if self.hand_cards[VIEW_INDEX_SELF] == nil then
        return {}
    end

    local table_hand_cards={}
    for k,v in pairs(self.hand_cards[VIEW_INDEX_SELF]) do
        local card=self.hand_cards[VIEW_INDEX_SELF][k]
        table.insert(table_hand_cards,card)
    end

    return table_hand_cards;
end

function card_layer:insert_hand_card(cards,count)
    if cards == nil or self.hand_cards[VIEW_INDEX_SELF] == nil then
        return
    end
    
    if count == 1 then
        table.insert(self.hand_cards[VIEW_INDEX_SELF],cards);
        return;
    end
    for i=1,count,1 do
        table.insert(self.hand_cards[VIEW_INDEX_SELF],cards[i]);
    end
end

function card_layer:remove_hand_card(card)
    for k,v in pairs(self.hand_cards[VIEW_INDEX_SELF]) do
        local card_value = self.hand_cards[VIEW_INDEX_SELF][k]
        if card_value == card then
            table.remove(self.hand_cards[VIEW_INDEX_SELF],k);
            break;
        end
    end
    
end

function card_layer:remove_hand_cards(cards,count)
    if count == 0 or type(cards)~= type({}) then
        return
    end
    
    for i=1,count,1 do
        if i>#cards then
            break;
        end
        self.remove_hand_card(cards[i]);
    end
    
end
--------------------------------------------------------------------------------

big_card_sprite = class("big_card_sprite")

function big_card_sprite.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, big_card_sprite)
    return target
end
--------------------------------------------------------------------------------
-- 属性
--------------------------------------------------------------------------------
big_card_sprite.byte_card=nil 
big_card_sprite.ptr_card=nil
--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------
function big_card_sprite:set_card(card)
    if card<11 or card>58 then
        return;
    end
    self.byte_card = card;
    self.ptr_card:showCard(card)
end

function big_card_sprite:get_card(card)
    return self.byte_card
end

function big_card_sprite:init()
    self:loadTexture("big_card_bg.png",1);
    if self.ptr_card==nil then
       self.ptr_card=cards_3d_layout:getNewHandCard(true);
       self.ptr_card:setPosition(ccp(0,-5));
       self.ptr_card:setScale(1.05)
       self:addChild(self.ptr_card);
    end
end

function big_card_sprite:create()
    local layer = big_card_sprite.extend(ImageView:create())
    layer:setVisible(false)
    layer:setTouchEnabled(false)
    layer:init()
    return layer
end
--------------------------------------------------------------------------------
--endregion
