--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

new_player_hint = class("new_player_hint")

function new_player_hint.extend(target)
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target, t)
	end
	setmetatable(t, new_player_hint)
	return target
end

function new_player_hint:create(visibleSize)
	local layer = new_player_hint.extend(Layout:create())
    if layer ~= nil then
    	layer:init(visibleSize)
    end
	return layer
end

function new_player_hint:init(visibleSize)
    self:setSize(visibleSize);
    
    self.img_hand_list = {}
    self.btn_hint_list = {}

    self.count = 2;
    for i=1, self.count, 1 do
        local img_hand = ImageView:create();
        self:addChild(img_hand);
        img_hand:loadTexture("228_hand.png",1);
        img_hand:setPosition(ccp(visibleSize.width/2, visibleSize.height/2) );
        img_hand:setVisible(false)
        table.insert(self.img_hand_list,img_hand);

        local btn_hint = UIButtonExSmall:create()
        self:addChild(btn_hint);
        btn_hint:loadTextureNormal("resources/228_new_player_hint_"..i..".png");
        btn_hint:setPosition(ccp(visibleSize.width/2, visibleSize.height/2) );
        btn_hint:addTouchEventListener(function(sender, touchType) self:on_btn_hint(sender, touchType, i) end )
        btn_hint:setVisible(false)
        table.insert(self.btn_hint_list,btn_hint);
    end
    self.img_hand_list[1]:setPosition(ccp(180 + game_layer.screenGap, visibleSize.height - 150));
    self.btn_hint_list[1]:setPosition(ccp(380 + game_layer.screenGap, visibleSize.height - 170));

    self.img_hand_list[2]:setPosition(ccp(visibleSize.width - 50 - game_layer.screenGap, visibleSize.height - 150));
    self.btn_hint_list[2]:setPosition(ccp(visibleSize.width - 250 - game_layer.screenGap, visibleSize.height - 170));


--    self.test = UIButtonExSmall:create()
--    self:addChild(self.test);
--    self.test:loadTextureNormal("btn_ting.png",1);
--    self.test:setPosition(ccp(visibleSize.width/2, visibleSize.height/2) );
--    self.test:addTouchEventListener(function(sender, touchType) frame_tools:set_config_value("228_version",0); end )

end

function new_player_hint:show_hint(index)
    for i=1,self.count,1 do
        self.img_hand_list[i]:setVisible(false);
        self.btn_hint_list[i]:setVisible(false);
    end
    self.img_hand_list[index]:setVisible(true);
    self.btn_hint_list[index]:setVisible(true);

    self.btn_hint_list[index]:setOpacity(255);

    local array = CCArray:create();
    array:addObject(CCDelayTime:create(6));
    array:addObject(CCFadeOut:create(1));
    array:addObject(CCCallFunc:create(function() self:on_btn_hint(0,_G.TOUCH_EVENT_ENDED,index) end));

    self.btn_hint_list[index]:runAction(CCSequence:create(array));
end

function new_player_hint:on_btn_hint(sender, touchType, index)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    self.btn_hint_list[index]:stopAllActions();
    self.img_hand_list[index]:setVisible(false);
    self.btn_hint_list[index]:setVisible(false);

    if index < self.count then
        self:show_hint(index + 1);
    end

end
--endregion
