--------------------------------------------------------------------------------
-- 工具条
--------------------------------------------------------------------------------
right_bar = class("right_bar")

function right_bar.extend(target)
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target, t)
	end
	setmetatable(t, right_bar)
	return target
end

--------------------------------------------------------------------------------
-- 属性
--------------------------------------------------------------------------------
right_bar.is_open = false;
right_bar.scale_size = 1.1;
--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------
function right_bar:closeBar()
    self.btn_config:stopAllActions();
    self.btn_help:stopAllActions();
    self.btn_return:stopAllActions();
    self.back_ground:stopAllActions();

    self.btn_config:runAction(CCScaleTo:create(0.2,0));
    self.btn_help:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(0.1),CCScaleTo:create(0.1,0))); 
    self.btn_return:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(0.2),CCScaleTo:create(0.1,0))); 
    self.back_ground:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(0.3),CCMoveTo:create(0.2,ccp(self.bgWidth*3/2,self.bgHeight/2))));
end

function right_bar:openBar()
    self.btn_config:stopAllActions();
    self.btn_help:stopAllActions();
    self.btn_return:stopAllActions();
    self.back_ground:stopAllActions();

    self.back_ground:runAction(CCMoveTo:create(0.2,ccp(self.bgWidth/2,self.bgHeight/2)));
    self.btn_return:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(0.2),CCScaleTo:create(0.2,1))); 
    self.btn_help:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(0.3),CCScaleTo:create(0.2,1))); 
    self.btn_config:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(0.4),CCScaleTo:create(0.2,1))); 
end

function right_bar:show_right_bar()
    if self.is_open == true then
        self.btn_menu:loadTextureNormal("img_open.png",1)
        self:closeBar();
    else
        self.btn_menu:loadTextureNormal("img_close.png",1)
        self:openBar();
    end

    self.is_open = not self.is_open;
end

function right_bar:init(visibleSize)
    self:setSize(visibleSize);
    
    --开关
    self.btn_menu = button_event:create(ButtonEventName.btn_menu, ButtonEventType.btn_menu);
    self.btn_menu:setPosition(ccp(visibleSize.width/2, visibleSize.height/2));
    self:addChild(self.btn_menu);
    self.btn_menu:setScale(right_bar.scale_size);

    self.bgScroll = UIHelper.create_scroll(self,ccp(0, 0),CCSizeMake(0,0),_G.SCROLLVIEW_DIR_HORIZONTAL)
    self.bgScroll:setTouchEnabled(false)
    self.bgScroll:setAnchorPoint(ccp(0.5, 0.5))
    self.bgScroll:setScale(right_bar.scale_size);

    self.back_ground = UIHelper.create_img(self.bgScroll, ccp(0, 0), "bg_menu.png",1);
    
    self.bgWidth = self.back_ground:getSize().width;
    self.bgHeight = self.back_ground:getSize().height;
    self.back_ground:setPosition(ccp(self.bgWidth*3/2,self.bgHeight/2));
    self.bgScroll:setPosition(ccp(visibleSize.width/2 - self.bgWidth/2,visibleSize.height/2));
    self.bgScroll:setSize(CCSizeMake(self.bgWidth,self.bgHeight));

    -- 设置
    self.btn_config = button_event:create(ButtonEventName.btn_config, ButtonEventType.btn_config)
    self.btn_config:setPosition(ccp( -self.bgWidth/4 - 20, 0))
    self.back_ground:addChild(self.btn_config)
    self.btn_config:setScale(0)

    -- 帮助
    self.btn_help = button_event:create(ButtonEventName.btn_help, ButtonEventType.btn_help)
    self.btn_help:setPosition(ccp( -20, 0))
    self.back_ground:addChild(self.btn_help) 
    self.btn_help:setScale(0);

    -- 退出
    self.btn_return = button_event:create(ButtonEventName.btn_return, ButtonEventType.btn_return)
    self.btn_return:setPosition(ccp(self.bgWidth/4 - 20, 0))
    self.back_ground:addChild(self.btn_return)
    self.btn_return:setScale(0);

--   local function touchEvent( sender, eventType )
--       if eventType == _G.TOUCH_EVENT_ENDED then
--           print("----------------------------关闭啦")
--           self:show_right_bar()
--       end
--   end 
--   self:addTouchEventListener(touchEvent)
--   self:setTouchEnabled(true)
end

function right_bar:create(visibleSize)
	local layer = right_bar.extend(Layout:create())
    if layer ~= nil then
    	layer:init(visibleSize)
    end
	return layer
end