--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
--------------------------------------------------------------------------------
-- 牌
--------------------------------------------------------------------------------
CTingCard = class("CTingCard");

function CTingCard.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, CTingCard)
    return target
end

function CTingCard:create()
    local layer = CTingCard.extend(ImageView:create())
    layer:setVisible(false)
    layer:setTouchEnabled(false)
    layer:init()
    return layer
end

function CTingCard:init()
    self.card = cards_3d_layout:getNewHandCard(true);
    self:addChild(self.card);

    self.img_count_bg = UIHelper.create_img(self.card,ccp(-25,45),"count_point.png",1);
    self.label_count = UIHelper.create_label(self.img_count_bg,ccp(0,0),20);
    
    self.label_fan = UIHelper.create_labelBM(self.card,"resources/number_gold/num_fx.fnt",ccp(0,-70));

    self.width = CardInfo.CARD_RESOURCE_WIDTH * game_layer.HAND_CARD_SCALE;
  
    self.card:setScale(game_layer.HAND_CARD_SCALE);
end

function CTingCard:showCard(card)
    self.card:showCard(card)
end

function CTingCard:setCount(count)
    self.label_count:setText(tostring(count));
end

function CTingCard:showCorner(args)
    self.card:showCorner(args)
end

function CTingCard:setFan(fan)
    if fan == 0 then
        self.label_fan:setVisible(false);
        return;
    end
    self.label_fan:setVisible(true);
    self.label_fan:setText(fan.."番");
end

function CTingCard:getSelfWidth(args)
    return self.width;
end
--------------------------------------------------------------------------------
-- 听牌提示界面
--------------------------------------------------------------------------------
ting_hint_layer = class("ting_hint_layer")

function ting_hint_layer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, ting_hint_layer)
    return target
end

--------------------------------------------------------------------------------
-- 属性
--------------------------------------------------------------------------------
ting_hint_layer.ptr_background=nil 
ting_hint_layer.visibleSize=nil

ting_hint_layer.table_cards={}  

ting_hint_layer.card_scale = 0.6
--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------
function ting_hint_layer:get_one_card()
    local local_card = CTingCard:create();
    return local_card;
end

function ting_hint_layer:set_hu_card(hu_size,hu_cards,card_count)
    if #self.table_cards<card_count then
        for i=1,card_count-#self.table_cards do
            local card = self:get_one_card();
            self.ptr_background:addChild(card);
            table.insert(self.table_cards, card)
        end
    end

    local float_start_x = 50;
    local float_start_y = 90;
    local float_x = float_start_x;
    local float_y = float_start_y;
    local float_gap_x = 65;
    local float_gap_y = 0;

    local int_index = 1;
    for k,cards in pairs(hu_cards) do
        for k1,card in pairs(cards) do
            self.table_cards[int_index]:showCard(card);
            self.table_cards[int_index]:setFan(hu_size[k]);
            if card == game_layer.byte_caishen_card then
                self.table_cards[int_index]:showCorner(7);
            else
                self.table_cards[int_index]:showCorner(0);
            end

            float_gap_x = self.table_cards[int_index]:getSelfWidth();

            local int_card_count = 0;
            if card % 10 == 0 then
                for i=1,9 do
                    int_card_count = int_card_count + game_layer.get_remain_card_count(card + i);
                end
            else
                int_card_count = game_layer.get_remain_card_count(card);
            end
            if int_card_count > game_layer.int_residue_cards then
                int_card_count = game_layer.int_residue_cards
            end
            if int_card_count < 0 then
                int_card_count = 0
            end

            self.table_cards[int_index]:setCount(int_card_count);
            self.table_cards[int_index]:setVisible(true);
            self.table_cards[int_index]:setPosition(ccp(float_x,float_y));

            int_index = int_index + 1;

            float_x = float_x + float_gap_x;
        end
    end
    
    for i=card_count + 1, #self.table_cards do
        self.table_cards[i]:setVisible(false); 
    end

    local float_width = float_x - 15;
    if float_width < self.width_bg then 
        float_x = (self.width_bg - float_width)/2 + float_start_x
        for i=1,card_count,1 do
            self.table_cards[i]:setPosition(ccp(float_x,float_y));
            float_x = float_x + float_gap_x;
        end
        float_width = self.width_bg;
    end

    self.img_title:setPosition(ccp(float_width/2,180));
    self.ptr_background:setSize(CCSizeMake(float_width,210));
    self.ptr_background:setPosition(ccp(self.visibleSize.width/2 - float_width/2,self.visibleSize.height/4));
end

function ting_hint_layer:init(visibleSize)
    self.visibleSize=visibleSize
    self.width_bg = 400;
    if self.ptr_background == nil then
        self.ptr_background = ImageView:create();
	    self.ptr_background:loadTexture("hint_ting_bg.png",1);
	    self:addChild(self.ptr_background);
	    self.ptr_background:setScale9Enabled(true);
	    self.ptr_background:setPosition(ccp(visibleSize.width/2, visibleSize.height/2));
	    self.ptr_background:setAnchorPoint(ccp(0,0));
        self.ptr_background:setSize(CCSizeMake(400,210));
    end

    self.img_title = UIHelper.create_img(self.ptr_background,ccp(0,180),"ting_title.png",1);
    

end

function ting_hint_layer:create(visibleSize)
    local layer = ting_hint_layer.extend(Layout:create())
    layer:setSize(visibleSize);
    layer:setVisible(false)
    layer:setTouchEnabled(false)
    layer:init(visibleSize)
    return layer
end


--endregion
