--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

--------------------------------------------------------------------------------
-- 听牌提示界面
--------------------------------------------------------------------------------
ting_hint_layer = class("ting_hint_layer")

function ting_hint_layer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, ting_hint_layer)
    return target
end

--------------------------------------------------------------------------------
-- 属性
--------------------------------------------------------------------------------
ting_hint_layer.ptr_background=nil 
ting_hint_layer.visibleSize=nil

ting_hint_layer.table_cards={}  
ting_hint_layer.table_tai_shu={}
ting_hint_layer.table_card_count={}

ting_hint_layer.card_scale = 0.6
--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------
function ting_hint_layer:get_one_card()
    local local_card;
    
    local_card = cards_3d_layout:getNewHandCard(true);
    local_card:setScale(self.card_scale);
   
    return local_card;
end

function ting_hint_layer:set_hu_card(hu_size,hu_cards,card_count,hua_count)
    if #self.table_cards<card_count then
        for i=1,card_count-#self.table_cards do
            local card = self:get_one_card();
            self.ptr_background:addChild(card);
            table.insert(self.table_cards, card)
        end
    end
    if #self.table_tai_shu<#hu_size then
        for i=1,#hu_size-#self.table_tai_shu do
            local label=Label:create();
            label:setFontSize(24);
            label:setColor(ccc3(253,238,114));
            self.ptr_background:addChild(label);
            table.insert(self.table_tai_shu, label)
        end
    end
    if #self.table_card_count<#hu_size then
        for i=1,#hu_size-#self.table_card_count do
            local label=Label:create();
            label:setFontSize(24);
            label:setColor(ccc3(253,238,114));
            self.ptr_background:addChild(label);
            table.insert(self.table_card_count, label)
        end
    end
    
    local float_start_x = 150;
    local float_start_y = -28;
    local float_item_width = 0;
    local float_most_x = float_start_x;
    local float_most_y = 0;

    local float_start_x_bagin = 0;
    local float_start_y_bagin = -35;

    local int_index = 1;
    for k,v in pairs(hu_cards) do
        float_start_y = float_start_y + 65
        float_start_x = float_start_x_bagin + 150;

        local int_card_count=0;
        for k1,v1 in pairs(v) do
            if v1<=58 and v1>=10 then
                self.table_cards[int_index]:showCard(v1);   
                self.table_cards[int_index]:setPosition(ccp(float_start_x,float_start_y - 2));
                self.table_cards[int_index]:setVisible(true);
                if (float_item_width == 0) then
			        float_item_width = self.table_cards[int_index]:getSize().width * self.card_scale - 5;
                end
                float_start_x = float_start_x + float_item_width;
                int_index = int_index + 1;
                
                if v1 % 10 == 0 then
                    for i=1,9 do
                         int_card_count = int_card_count + game_layer.get_remain_card_count(v1 + i);
                    end
                else
                    int_card_count = int_card_count + game_layer.get_remain_card_count(v1);
                end
                if int_card_count > game_layer.int_residue_cards then
                    int_card_count = game_layer.int_residue_cards
                end
            end
        end

        local int_max_width=0;
        if #hu_size >= k then
            self.table_tai_shu[k]:setText("分数:"..hu_size[k])
            local int_tai_shu_width=self.table_tai_shu[k]:getSize().width
            self.table_tai_shu[k]:setPosition(ccp(int_tai_shu_width / 2 + 5 + float_start_x_bagin,18 + float_start_y));
            int_max_width=int_tai_shu_width;
            self.table_tai_shu[k]:setVisible(true);

            self.table_card_count[k]:setText("张数:"..int_card_count)
            local int_card_count_width=self.table_card_count[k]:getSize().width
            self.table_card_count[k]:setPosition(ccp(int_card_count_width / 2 + 5 + float_start_x_bagin,-18 + float_start_y));
            if int_card_count_width>int_max_width then
                int_max_width=int_card_count_width;
            end
            self.table_card_count[k]:setVisible(true);
        end

        if float_most_x < float_start_x then
            float_most_x = float_start_x;
        end
        if float_most_y < float_start_y then
            float_most_y = float_start_y;
        end
      
        if k % 6 == 0 then
            float_start_x_bagin = float_most_x;
            float_start_y = float_start_y_bagin;
        end
    end

    for i=card_count + 1, #self.table_cards do
        self.table_cards[i]:setVisible(false); 
    end
    for i=#hu_size + 1,#self.table_tai_shu do
        self.table_tai_shu[i]:setVisible(false); 
        self.table_card_count[i]:setVisible(false); 
    end
    
    self.ptr_background:setSize(CCSizeMake(float_most_x - 15,float_most_y + 40));
    self.ptr_background:setPosition(ccp(self.visibleSize.width - float_most_x - 100, self.visibleSize.height/4));
end

function ting_hint_layer:init(visibleSize)
    self.visibleSize=visibleSize

    if self.ptr_background == nil then
        self.ptr_background = ImageView:create();
	    self.ptr_background:loadTexture("bg_black.png",1);
	    self:addChild(self.ptr_background);
	    self.ptr_background:setScale9Enabled(true);
	    self.ptr_background:setPosition(ccp(visibleSize.width/2, visibleSize.height/2));
	    self.ptr_background:setAnchorPoint(ccp(0,0));
        self.ptr_background:setSize(CCSizeMake(150,80));
    end

end

function ting_hint_layer:create(visibleSize)
    local layer = ting_hint_layer.extend(Layout:create())
    layer:setSize(visibleSize);
    layer:setVisible(false)
    layer:setTouchEnabled(false)
    layer:init(visibleSize)
    return layer
end

--------------------------------------------------------------------------------
-- 浮动文字界面
--------------------------------------------------------------------------------
gold_text_layer = class("gold_text_layer")

function gold_text_layer.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, gold_text_layer)
    return target
end

--------------------------------------------------------------------------------
-- 属性
--------------------------------------------------------------------------------
gold_text_layer.ptr_text_label={}

--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------
function gold_text_layer:show_score(table_score)
    if table_score==nil or #table_score~=GAME_PLAYER then 
        return
    end
    for i=1,GAME_PLAYER  do
        local view_id = game_layer.switch_to_view_id(i-1);
        if table_score[i]>=0 then
            self.ptr_text_label[view_id]:setFntFile("resources/number_gold/num_jsjm_d.fnt");
            self.ptr_text_label[view_id]:setText("+"..table_score[i]);
        else
            self.ptr_text_label[view_id]:setFntFile("resources/number_gold/num_jsjm_d2.fnt");
            self.ptr_text_label[view_id]:setText(table_score[i]);
        end
        self.ptr_text_label[view_id]:setPosition(ccp(game_layer.game_user.player_pos[view_id].x,game_layer.game_user.player_pos[view_id].y + 30));
        self.ptr_text_label[view_id]:stopAllActions();
        self.ptr_text_label[view_id]:setVisible(true);

        local array=CCArray:create()
        array:addObject(CCFadeIn:create(0))
        array:addObject(CCFadeOut:create(2.5))

        self.ptr_text_label[view_id]:runAction(CCSequence:create(array));
        self.ptr_text_label[view_id]:runAction(CCMoveBy:create(2.5, ccp(0, 50)));
    end
end

function gold_text_layer:init(visibleSize)
    for i=1,GAME_PLAYER  do
        local lable_text=UIHelper.create_labelBM(self,"resources/number_gold/num_jsjm_d.fnt",game_layer.game_user.player_pos[i]);
        lable_text:setVisible(false)
        table.insert(self.ptr_text_label,lable_text);
    end
    
end

function gold_text_layer:create(visibleSize)
    local layer = gold_text_layer.extend(Layout:create())
    layer:setSize(visibleSize);
    layer:setVisible(true)
    layer:setTouchEnabled(false)
    layer:init(visibleSize)
    return layer
end


--endregion
